; PI Intruders
;       note that's PI as in the PI symbol (3.1415...)
;       also note that this is NOT A MATH GAME
;
; Version 1.1 for IBM-PC
;
; Author:  Eric Hood
;
; Description:
;       A simple shoot'em up where you have to shoot the disgusting
;       PI creatures that are invading Earth.
;
; Assembler:
;       Developed and Tested with TASM
;       Assembles as a COM executable since all data, stack, and code
;       fit in less than 64k.
; History:
;       A rewrite of a z80 version of the game that executed on
;       a TI-83 graphing calculator with an LCD display.
;       Color graphics have been added, a neat starfield background,
;       and some more interesting gameplay.  Scoring has not been
;       decided yet.
;
; TODO:
;       Extra ships.  Currently the game declares "you won" if
;       you figure out how to keep the PIs from coming back. (Read on)
;       Maybe add a boss.
; BUGS:
;       The gameplay seems a bit choppy sometimes.  Not sure exactly why. 
; 
;       Definitely needs a better way of reading keyboard input as BIOS calls
;       are used currently.  This means moving can only be left, right, up,
;       and down since combinations of keys can't be detected.  Also shooting can
;       only be done while not moving, but this does make it a bit more challenging.
;
;       When I tested it on other systems I realized that the repeat rate is
;       set lower on some and the ship is hard to move.  To make it more
;       playable I need to figure out how to do some sort of direct keyboard
;       input instead of using bios routines.
;
;
; HOW TO PLAY:
;        Run INTRUDER.COM and press any key at title screen to begin.
;        Press ESCAPE during game to QUIT.
;
;        The arrow keys move your ship left, right, up, and down
;        around the screen.  Spacebar fires your gun.
;
;        Once the game has begun, ugly PI shaped creatures
;        will begin approaching your ship.  You can fire at them
;        to destroy them.  You have unlimited fire but Watch Out!
;        If you collide with one they will try to push you off
;        the screen!  If you fall off the bottom of the screen,
;        your game is over.
;
;        If you find yourself being dragged by a PI you can hold
;        UP KEY to move over them.  But this might not work if you're
;        arleady too close to the end, as it might take too long to get
;        out of its clunches.
;
;        HOW TO WIN?
;        If you play around with the game for a bit you'll discover
;        some interesting characteristics about how the PIs and their
;        corpses respond to your fire.  See if you can figure out
;        how to keep the creatures from coming back.
;        If you just wanna know how to win,
;        look at the bottom of the source code.
;
;
;        THE SOURCE:
;        It's been messed with a lot up to this version and much
;        documentation has yet to be added.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


TITLE PI_Intruders
.model tiny
.386

.data



; sprites
sprite_ship     dw 35,35
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,07h,09h,05h,05h,08h,05h,05h,09h,07h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,07h,07h,09h,09h,09h,09h,09h,07h,07h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,05h,04h,08h,010h,08h,04h,05h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,05h,04h,08h,010h,010h,08h,04h,05h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,05h,04h,08h,010h,010h,010h,08h,04h,05h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,05h,04h,08h,010h,010h,04h,010h,08h,04h,05h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,05h,04h,08h,010h,010h,010h,010h,04h,08h,04h,05h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,05h,04h,08h,010h,010h,010h,010h,010h,010h,08h,04h,05h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,05h,04h,08h,04h,010h,010h,010h,010h,010h,010h,08h,04h,05h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,05h,04h,08h,04h,010h,010h,010h,010h,010h,010h,04h,08h,04h,05h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,05h,04h,08h,06h,04h,04h,04h,04h,04h,04h,04h,04h,08h,04h,05h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,05h,04h,08h,05h,05h,05h,05h,05h,05h,05h,05h,05h,05h,08h,04h,05h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,05h,04h,08h,06h,06h,06h,06h,06h,06h,06h,06h,06h,06h,08h,04h,05h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,05h,04h,08h,08h,08h,08h,08h,08h,08h,08h,08h,08h,08h,08h,08h,08h,04h,05h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,05h,04h,011h,07h,07h,07h,04h,04h,08h,08h,04h,04h,07h,07h,06h,011h,04h,05h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,05h,04h,08h,06h,06h,07h,06h,07h,04h,08h,08h,04h,07h,05h,05h,05h,06h,08h,04h,05h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,05h,04h,08h,06h,06h,06h,06h,07h,04h,08h,08h,04h,04h,07h,05h,05h,06h,06h,04h,05h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,05h,04h,08h,06h,06h,04h,04h,04h,07h,04h,08h,08h,04h,04h,07h,05h,04h,04h,06h,08h,04h,05h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,05h,04h,08h,06h,04h,04h,04h,04h,07h,04h,08h,08h,04h,04h,04h,07h,04h,04h,06h,06h,08h,05h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,05h,04h,08h,06h,06h,05h,05h,05h,07h,04h,04h,08h,08h,04h,04h,04h,07h,05h,05h,06h,06h,08h,04h,05h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,05h,04h,08h,06h,05h,05h,05h,07h,04h,04h,04h,08h,08h,04h,04h,04h,04h,07h,07h,07h,06h,011h,08h,05h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,05h,08h,011h,06h,05h,07h,07h,04h,04h,04h,04h,08h,08h,04h,04h,04h,04h,04h,04h,07h,07h,07h,08h,04h,05h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,05h,04h,08h,07h,07h,07h,04h,04h,04h,04h,04h,04h,08h,08h,04h,04h,04h,04h,04h,04h,04h,04h,04h,04h,08h,05h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,05h,04h,08h,08h,08h,08h,08h,08h,08h,08h,08h,08h,08h,08h,08h,08h,08h,08h,08h,08h,08h,08h,08h,08h,08h,04h,05h,00h,00h,00h,00h
db 00h,00h,00h,05h,04h,08h,07h,07h,07h,07h,07h,07h,07h,07h,07h,07h,07h,07h,07h,07h,07h,07h,07h,07h,07h,07h,07h,07h,07h,08h,05h,00h,00h,00h,00h
db 00h,00h,00h,05h,04h,08h,06h,06h,06h,06h,06h,06h,06h,06h,06h,06h,06h,06h,06h,06h,06h,06h,06h,06h,06h,06h,06h,06h,06h,04h,04h,05h,00h,00h,00h
db 00h,00h,05h,04h,08h,04h,04h,04h,04h,04h,04h,04h,04h,04h,04h,04h,04h,04h,04h,04h,04h,04h,04h,04h,04h,04h,04h,04h,04h,04h,08h,05h,00h,00h,00h
db 00h,00h,05h,04h,08h,03h,03h,03h,03h,03h,03h,03h,03h,03h,03h,03h,03h,03h,03h,03h,03h,03h,03h,03h,03h,03h,03h,03h,03h,03h,03h,04h,05h,00h,00h
db 00h,05h,04h,08h,04h,04h,04h,04h,04h,04h,04h,04h,04h,04h,04h,04h,04h,04h,04h,04h,04h,04h,04h,04h,04h,04h,04h,04h,04h,04h,04h,08h,05h,00h,00h
db 00h,05h,04h,08h,05h,05h,05h,05h,05h,04h,04h,04h,05h,05h,05h,05h,05h,05h,05h,04h,04h,05h,05h,05h,05h,05h,05h,04h,05h,05h,05h,05h,08h,05h,00h
db 05h,04h,08h,05h,07h,07h,07h,07h,05h,05h,05h,05h,05h,07h,07h,07h,07h,07h,05h,05h,04h,05h,07h,07h,07h,07h,05h,05h,05h,07h,07h,07h,08h,05h,00h
db 05h,04h,08h,07h,08h,08h,08h,08h,07h,05h,05h,05h,07h,08h,08h,08h,08h,08h,07h,05h,05h,07h,08h,08h,08h,08h,07h,05h,07h,08h,08h,08h,08h,04h,05h
db 04h,08h,07h,08h,013h,014h,013h,013h,08h,07h,05h,07h,08h,013h,013h,014h,013h,013h,08h,07h,05h,08h,013h,013h,014h,013h,08h,05h,08h,013h,013h,014h,08h,08h,05h
db 00h,08h,08h,08h,012h,013h,014h,012h,08h,08h,08h,08h,08h,012h,014h,013h,014h,012h,08h,08h,08h,08h,012h,014h,013h,012h,08h,08h,08h,012h,014h,013h,012h,08h,00h
db 00h,00h,05h,05h,08h,08h,08h,08h,05h,05h,05h,05h,05h,08h,08h,08h,08h,08h,05h,05h,05h,05h,08h,08h,08h,08h,05h,05h,05h,08h,08h,08h,08h,05h,00h



sprite_pi       dw 32,32
db 00h,00h,00h,00h,00h,00h,00h,0bh,0bh,0bh,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,0bh,0bh,0bh,0bh,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,0bh,016h,016h,016h,0bh,00h,00h,00h,00h,00h,00h,00h,00h,0bh,016h,016h,016h,0bh,0bh,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,0bh,016h,01ch,01dh,01dh,016h,00h,00h,00h,00h,00h,00h,00h,00h,016h,01ch,01dh,01dh,01ch,016h,0bh,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,0bh,016h,01ch,01ch,01dh,01dh,01ch,016h,00h,00h,00h,00h,00h,00h,016h,01ch,01ch,01dh,01dh,01ch,01ch,016h,0bh,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,0bh,016h,012h,012h,01ch,01ch,012h,016h,00h,00h,00h,00h,00h,00h,016h,012h,012h,01ch,01ch,012h,012h,016h,0bh,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,0bh,015h,015h,015h,015h,015h,00h,00h,00h,00h,00h,00h,00h,00h,016h,015h,015h,015h,015h,016h,0bh,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,018h,018h,016h,016h,016h,016h,016h,016h,016h,016h,016h,018h,016h,016h,016h,016h,016h,016h,016h,016h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,016h,016h,016h,016h,016h,016h,016h,016h,016h,016h,016h,016h,016h,016h,016h,016h,016h,016h,016h,016h,016h,016h,016h,016h,016h,00h,00h
db 00h,016h,016h,016h,016h,016h,016h,016h,016h,016h,017h,019h,018h,019h,018h,018h,019h,019h,018h,019h,019h,019h,017h,016h,016h,016h,016h,018h,018h,017h,016h,00h
db 016h,017h,019h,018h,018h,017h,017h,017h,017h,018h,018h,019h,018h,019h,019h,018h,019h,019h,019h,018h,018h,019h,019h,019h,018h,019h,019h,019h,018h,019h,017h,016h
db 016h,017h,018h,019h,019h,019h,018h,018h,019h,019h,018h,019h,018h,019h,019h,018h,018h,019h,019h,019h,018h,019h,019h,019h,018h,018h,019h,019h,019h,018h,017h,016h
db 016h,017h,017h,018h,019h,019h,019h,018h,019h,019h,018h,019h,018h,019h,019h,019h,018h,019h,019h,019h,019h,018h,019h,019h,019h,017h,017h,018h,019h,018h,016h,00h
db 00h,016h,016h,016h,018h,019h,019h,019h,018h,017h,016h,018h,018h,018h,018h,018h,018h,018h,018h,018h,018h,016h,016h,017h,018h,018h,018h,016h,016h,016h,00h,00h
db 00h,00h,00h,00h,016h,016h,018h,018h,018h,017h,016h,00h,00h,08h,05h,08h,00h,08h,05h,08h,00h,00h,016h,017h,018h,018h,017h,016h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,016h,017h,019h,019h,017h,016h,016h,00h,08h,05h,08h,00h,08h,05h,08h,00h,00h,016h,017h,019h,018h,017h,016h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,016h,017h,017h,018h,017h,017h,016h,00h,08h,05h,08h,00h,08h,05h,08h,00h,016h,016h,017h,019h,018h,017h,016h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,016h,017h,017h,019h,019h,017h,016h,00h,08h,05h,08h,00h,08h,05h,08h,00h,016h,017h,017h,019h,018h,017h,016h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,016h,017h,018h,018h,017h,016h,00h,08h,05h,08h,00h,08h,05h,08h,00h,016h,017h,018h,018h,018h,017h,016h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,016h,017h,019h,019h,017h,016h,00h,00h,08h,00h,00h,00h,08h,00h,00h,016h,017h,019h,018h,018h,017h,016h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,016h,017h,018h,019h,017h,016h,00h,00h,00h,00h,00h,00h,00h,00h,00h,016h,017h,019h,019h,018h,017h,016h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,016h,017h,018h,018h,017h,016h,00h,00h,00h,00h,00h,00h,00h,00h,00h,016h,017h,018h,019h,018h,017h,016h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,016h,017h,019h,019h,017h,016h,00h,00h,00h,00h,00h,00h,00h,00h,00h,016h,017h,019h,018h,018h,017h,016h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,016h,017h,019h,019h,017h,016h,00h,00h,00h,00h,00h,00h,00h,00h,00h,016h,017h,019h,019h,018h,017h,016h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,016h,017h,019h,017h,017h,016h,00h,00h,00h,00h,00h,00h,00h,00h,016h,017h,018h,019h,018h,018h,017h,016h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,016h,016h,017h,018h,017h,016h,016h,00h,00h,00h,00h,00h,00h,00h,00h,016h,017h,019h,018h,018h,017h,017h,016h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,016h,017h,017h,019h,017h,016h,015h,00h,00h,00h,00h,00h,00h,00h,00h,016h,017h,018h,018h,018h,017h,017h,016h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,016h,017h,018h,019h,017h,016h,00h,00h,00h,00h,00h,00h,00h,00h,00h,016h,017h,017h,017h,017h,017h,016h,016h,00h,00h,00h,00h
db 00h,00h,00h,00h,015h,016h,017h,018h,017h,017h,016h,00h,00h,00h,00h,00h,00h,00h,00h,015h,016h,016h,016h,016h,017h,017h,016h,015h,00h,00h,00h,00h
db 00h,00h,015h,015h,00h,016h,016h,016h,016h,016h,016h,015h,00h,00h,00h,00h,00h,00h,015h,00h,00h,00h,015h,015h,016h,016h,016h,00h,00h,00h,00h,00h
db 00h,015h,00h,00h,00h,00h,015h,00h,00h,015h,00h,00h,015h,00h,00h,00h,00h,015h,00h,00h,00h,00h,015h,00h,00h,015h,00h,015h,015h,00h,00h,00h
db 00h,00h,00h,00h,00h,015h,00h,00h,00h,015h,00h,00h,00h,015h,00h,00h,00h,00h,00h,00h,00h,015h,00h,00h,00h,015h,00h,00h,00h,015h,00h,00h
db 00h,00h,00h,00h,015h,00h,00h,00h,00h,00h,015h,00h,00h,00h,00h,00h,00h,00h,00h,00h,015h,00h,00h,00h,00h,00h,015h,00h,00h,00h,00h,00h

sprite_pi2      dw 32,32
db 00h,00h,00h,00h,00h,00h,00h,0bh,0bh,0bh,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,0bh,0bh,0bh,0bh,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,0bh,016h,016h,016h,0bh,00h,00h,00h,00h,00h,00h,00h,00h,0bh,016h,016h,016h,0bh,0bh,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,0bh,016h,01ch,01dh,01dh,016h,00h,00h,00h,00h,00h,00h,00h,00h,016h,01ch,01dh,01dh,01ch,016h,0bh,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,0bh,016h,01ch,01ch,01dh,01dh,01ch,016h,00h,00h,00h,00h,00h,00h,016h,01ch,01ch,01dh,01dh,01ch,01ch,016h,0bh,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,0bh,016h,012h,012h,01ch,01ch,012h,016h,00h,00h,00h,00h,00h,00h,016h,012h,012h,01ch,01ch,012h,012h,016h,0bh,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,0bh,015h,015h,015h,015h,015h,00h,00h,00h,00h,00h,00h,00h,00h,016h,015h,015h,015h,015h,016h,0bh,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,018h,018h,016h,016h,016h,016h,016h,016h,016h,016h,016h,018h,016h,016h,016h,016h,016h,016h,016h,016h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,016h,016h,016h,016h,016h,016h,016h,016h,016h,016h,016h,016h,016h,016h,016h,016h,016h,016h,016h,016h,016h,016h,016h,016h,016h,00h,00h
db 00h,016h,016h,016h,016h,016h,016h,016h,016h,016h,017h,019h,014h,019h,018h,014h,019h,014h,013h,019h,019h,019h,017h,016h,016h,016h,016h,014h,018h,017h,016h,00h
db 016h,014h,013h,018h,018h,014h,017h,017h,017h,014h,018h,019h,013h,019h,019h,013h,019h,019h,019h,013h,013h,019h,014h,019h,014h,019h,019h,019h,013h,019h,017h,016h
db 016h,017h,013h,019h,019h,013h,013h,018h,019h,014h,014h,019h,013h,019h,019h,018h,013h,019h,019h,019h,013h,019h,014h,019h,013h,013h,019h,019h,019h,013h,017h,016h
db 016h,017h,014h,018h,019h,019h,013h,013h,019h,019h,014h,019h,013h,019h,019h,019h,013h,019h,019h,019h,019h,013h,019h,014h,019h,013h,014h,018h,019h,013h,016h,00h
db 00h,016h,016h,016h,018h,019h,019h,013h,013h,017h,016h,018h,014h,018h,018h,018h,014h,018h,018h,018h,018h,014h,014h,017h,018h,018h,018h,016h,016h,016h,00h,00h
db 00h,00h,00h,00h,016h,016h,018h,018h,018h,014h,016h,00h,00h,08h,05h,08h,00h,08h,05h,08h,00h,00h,016h,017h,018h,018h,014h,016h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,016h,014h,019h,019h,017h,016h,016h,00h,08h,05h,08h,00h,08h,05h,08h,00h,00h,014h,013h,013h,013h,013h,016h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,016h,017h,014h,014h,014h,017h,016h,00h,08h,05h,08h,00h,08h,05h,08h,00h,016h,016h,017h,019h,018h,017h,016h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,016h,017h,017h,019h,019h,017h,016h,00h,08h,05h,08h,00h,08h,05h,08h,00h,016h,017h,017h,019h,018h,017h,016h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,014h,013h,013h,013h,014h,016h,00h,08h,05h,08h,00h,08h,05h,08h,00h,016h,014h,013h,013h,013h,013h,014h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,016h,017h,019h,019h,017h,016h,00h,00h,08h,00h,00h,00h,08h,00h,00h,016h,017h,019h,018h,018h,017h,016h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,016h,017h,018h,019h,017h,016h,00h,00h,00h,00h,00h,00h,00h,00h,00h,016h,017h,019h,019h,018h,017h,016h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,016h,014h,013h,013h,014h,016h,00h,00h,00h,00h,00h,00h,00h,00h,00h,016h,017h,014h,013h,018h,017h,016h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,016h,017h,019h,019h,017h,016h,00h,00h,00h,00h,00h,00h,00h,00h,00h,016h,017h,019h,013h,013h,017h,016h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,014h,014h,014h,019h,017h,016h,00h,00h,00h,00h,00h,00h,00h,00h,00h,016h,017h,019h,019h,013h,014h,016h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,016h,017h,019h,014h,014h,016h,00h,00h,00h,00h,00h,00h,00h,00h,016h,017h,018h,019h,018h,018h,017h,016h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,016h,014h,013h,013h,017h,016h,016h,00h,00h,00h,00h,00h,00h,00h,00h,016h,017h,019h,018h,018h,013h,014h,016h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,016h,017h,017h,013h,014h,016h,015h,00h,00h,00h,00h,00h,00h,00h,00h,016h,014h,013h,013h,013h,017h,017h,016h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,016h,017h,018h,019h,017h,016h,00h,00h,00h,00h,00h,00h,00h,00h,00h,016h,017h,017h,017h,017h,017h,016h,016h,00h,00h,00h,00h
db 00h,00h,00h,00h,015h,016h,014h,013h,013h,014h,016h,00h,00h,00h,00h,00h,00h,00h,00h,015h,016h,016h,014h,013h,013h,014h,016h,015h,00h,00h,00h,00h
db 00h,00h,015h,015h,00h,016h,016h,016h,016h,016h,016h,015h,00h,00h,00h,00h,00h,00h,015h,00h,00h,00h,015h,015h,016h,016h,016h,00h,00h,00h,00h,00h
db 00h,015h,00h,00h,00h,00h,015h,00h,00h,015h,00h,00h,015h,00h,00h,00h,00h,015h,00h,00h,00h,00h,015h,00h,00h,015h,00h,015h,015h,00h,00h,00h
db 00h,00h,00h,00h,00h,015h,00h,00h,00h,015h,00h,00h,00h,015h,00h,00h,00h,00h,00h,00h,00h,015h,00h,00h,00h,015h,00h,00h,00h,015h,00h,00h
db 00h,00h,00h,00h,015h,00h,00h,00h,00h,00h,015h,00h,00h,00h,00h,00h,00h,00h,00h,00h,015h,00h,00h,00h,00h,00h,015h,00h,00h,00h,00h,00h


sprite_pidead   dw      32,32
db 00h,00h,00h,0bh,0bh,0bh,018h,0bh,0bh,018h,018h,00h,012h,012h,00h,00h,00h,00h,00h,00h,00h,00h,0bh,012h,0bh,0bh,018h,0bh,00h,012h,00h,00h
db 00h,00h,00h,015h,015h,012h,015h,018h,015h,018h,0bh,00h,012h,00h,00h,00h,00h,00h,00h,00h,00h,00h,018h,012h,018h,018h,018h,018h,00h,00h,00h,00h
db 00h,012h,0bh,016h,018h,018h,012h,016h,018h,018h,0bh,012h,012h,00h,00h,012h,00h,00h,00h,00h,012h,018h,016h,012h,016h,016h,016h,012h,0bh,0bh,00h,00h
db 00h,0bh,012h,012h,016h,016h,012h,016h,016h,015h,0bh,018h,018h,00h,00h,00h,012h,012h,00h,00h,018h,012h,016h,016h,012h,016h,016h,016h,012h,012h,00h,012h
db 00h,016h,018h,01ch,012h,012h,012h,012h,012h,01ch,012h,012h,016h,018h,0bh,018h,00h,012h,012h,018h,016h,016h,012h,012h,012h,012h,012h,012h,012h,018h,012h,012h
db 00h,012h,016h,01ch,01ch,01dh,01dh,01dh,01dh,01ch,01ch,016h,016h,0bh,012h,00h,012h,012h,012h,012h,016h,016h,01ch,01ch,01dh,01dh,01dh,01dh,016h,016h,00h,00h
db 016h,01ch,01ch,01ch,01ch,01dh,01dh,01dh,01dh,01ch,01ch,01ch,01ch,012h,012h,012h,012h,012h,016h,016h,01ch,01ch,01ch,01ch,01dh,01dh,01dh,01dh,01ch,01ch,016h,016h
db 012h,01ch,01ch,01ch,01ch,01dh,01dh,01dh,01dh,01ch,01ch,01ch,01ch,016h,016h,0bh,0bh,0bh,012h,016h,01ch,01ch,01ch,01ch,01dh,01dh,01dh,01dh,01ch,01ch,016h,012h
db 016h,012h,012h,012h,012h,01ch,01ch,01ch,01ch,012h,012h,012h,012h,016h,016h,018h,018h,018h,016h,016h,012h,012h,012h,012h,01ch,01ch,01ch,01ch,012h,012h,016h,016h
db 012h,012h,012h,012h,012h,01ch,01ch,01ch,01ch,012h,012h,012h,012h,016h,018h,018h,018h,012h,012h,012h,012h,012h,012h,012h,01ch,01ch,01ch,01ch,012h,012h,012h,016h
db 012h,016h,016h,012h,015h,015h,015h,012h,012h,015h,012h,012h,016h,0bh,0bh,012h,012h,012h,0bh,0bh,015h,015h,012h,015h,015h,015h,015h,015h,012h,015h,012h,012h
db 016h,016h,016h,012h,015h,012h,012h,012h,015h,012h,015h,012h,016h,0bh,0bh,019h,018h,019h,0bh,012h,015h,012h,012h,015h,012h,012h,015h,015h,012h,015h,016h,00h
db 00h,016h,016h,012h,018h,012h,019h,012h,018h,012h,016h,012h,012h,018h,018h,018h,018h,018h,018h,018h,018h,012h,016h,017h,012h,012h,012h,016h,016h,012h,00h,00h
db 00h,00h,00h,012h,016h,012h,018h,012h,018h,017h,012h,00h,012h,012h,05h,08h,012h,08h,05h,012h,012h,012h,016h,017h,012h,012h,017h,012h,012h,00h,012h,00h
db 00h,012h,012h,00h,00h,012h,017h,012h,019h,017h,012h,016h,00h,06h,05h,06h,00h,06h,05h,06h,00h,012h,016h,017h,012h,012h,012h,016h,012h,00h,00h,012h
db 012h,00h,016h,017h,012h,018h,017h,012h,012h,012h,012h,012h,00h,012h,06h,012h,00h,00h,06h,00h,016h,016h,017h,019h,012h,017h,012h,00h,00h,00h,00h,00h
db 012h,00h,016h,017h,012h,019h,019h,012h,016h,012h,00h,012h,00h,00h,012h,00h,012h,00h,00h,012h,016h,017h,017h,012h,012h,017h,016h,00h,00h,00h,00h,00h
db 00h,00h,00h,016h,017h,018h,018h,012h,016h,00h,00h,00h,00h,012h,012h,00h,00h,00h,012h,012h,012h,017h,012h,018h,018h,017h,012h,00h,00h,00h,00h,00h
db 00h,00h,00h,016h,017h,019h,019h,017h,016h,00h,00h,012h,00h,00h,00h,00h,012h,00h,00h,012h,016h,017h,019h,018h,012h,012h,016h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,017h,018h,019h,017h,016h,012h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,012h,019h,018h,012h,00h,00h,012h,00h,00h,00h
db 00h,00h,00h,012h,00h,012h,012h,00h,016h,017h,018h,012h,00h,012h,00h,00h,00h,00h,00h,00h,00h,012h,00h,00h,017h,018h,019h,012h,017h,00h,00h,00h
db 00h,00h,00h,00h,012h,012h,00h,012h,012h,017h,019h,012h,017h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,012h,017h,019h,018h,018h,012h,016h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,016h,012h,019h,019h,017h,016h,012h,00h,00h,00h,00h,00h,00h,00h,00h,016h,012h,019h,012h,018h,012h,016h,012h,00h
db 00h,00h,00h,00h,00h,00h,012h,012h,016h,017h,019h,017h,017h,016h,00h,00h,00h,00h,00h,00h,00h,00h,012h,017h,018h,019h,018h,018h,017h,016h,00h,00h
db 00h,00h,00h,00h,00h,00h,012h,016h,016h,017h,018h,012h,016h,016h,00h,00h,00h,00h,00h,00h,00h,00h,016h,017h,019h,018h,018h,017h,017h,016h,00h,00h
db 00h,00h,00h,00h,00h,012h,00h,016h,017h,017h,019h,017h,016h,015h,00h,00h,00h,00h,00h,00h,00h,00h,016h,017h,018h,018h,018h,017h,017h,016h,00h,00h
db 00h,00h,00h,00h,00h,00h,012h,016h,017h,018h,019h,017h,016h,00h,00h,00h,00h,00h,00h,00h,00h,00h,016h,017h,017h,017h,017h,017h,016h,016h,00h,00h
db 00h,00h,00h,00h,00h,00h,015h,016h,017h,018h,017h,017h,016h,00h,00h,00h,00h,00h,00h,00h,00h,015h,016h,016h,016h,016h,017h,017h,016h,015h,00h,00h
db 00h,00h,00h,00h,015h,012h,012h,016h,016h,016h,016h,016h,016h,012h,00h,00h,00h,00h,00h,00h,015h,00h,012h,012h,015h,015h,016h,016h,016h,012h,00h,012h
db 00h,00h,00h,015h,00h,012h,012h,012h,015h,012h,012h,015h,012h,012h,012h,00h,00h,00h,00h,015h,00h,012h,012h,012h,015h,00h,012h,015h,012h,015h,015h,012h
db 00h,00h,00h,00h,012h,012h,00h,012h,00h,012h,012h,015h,012h,012h,012h,012h,00h,00h,00h,012h,012h,012h,012h,015h,012h,012h,012h,015h,012h,012h,012h,015h
db 00h,00h,00h,012h,012h,012h,015h,012h,012h,012h,012h,00h,015h,012h,00h,00h,00h,00h,012h,012h,012h,012h,015h,012h,012h,012h,00h,012h,015h,012h,00h,00h



sprite_shot     dw 8,16
db 00h,00h,00h,013h,013h,00h,00h,00h
db 00h,00h,013h,013h,00h,00h,00h,00h
db 00h,013h,013h,00h,00h,00h,00h,00h
db 013h,013h,00h,00h,00h,00h,00h,00h
db 00h,013h,013h,00h,00h,00h,00h,00h
db 00h,00h,013h,013h,00h,00h,00h,00h
db 00h,00h,00h,013h,013h,00h,00h,00h
db 00h,00h,00h,00h,013h,013h,00h,00h
db 00h,00h,00h,013h,013h,00h,00h,00h
db 00h,00h,013h,013h,00h,00h,00h,00h
db 00h,00h,00h,013h,013h,00h,00h,00h
db 00h,00h,00h,00h,00h,013h,013h,00h
db 00h,00h,00h,00h,00h,00h,013h,013h
db 00h,00h,00h,00h,00h,013h,013h,00h
db 00h,00h,00h,00h,013h,013h,00h,00h
db 00h,00h,00h,013h,013h,00h,00h,00h

sprite_gameover dw      64,32
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,01h,01h,01h,01h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,01h,01h,01h,01h,01h,01h,01h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,01h,01h,01h,00h,00h,01h,01h,01h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 01h,01h,01h,00h,00h,00h,00h,01h,01h,00h,00h,00h,00h,00h,00h,01h,01h,01h,01h,01h,01h,00h,00h,00h,01h,01h,01h,00h,01h,01h,01h,00h
db 00h,01h,01h,01h,00h,00h,00h,00h,00h,00h,01h,01h,01h,01h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 01h,01h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,01h,01h,01h,01h,01h,01h,01h,01h,00h,00h,01h,01h,01h,01h,01h,01h,01h,01h
db 01h,01h,01h,01h,01h,00h,00h,00h,00h,01h,01h,01h,01h,01h,01h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 01h,01h,01h,00h,00h,01h,01h,01h,01h,01h,00h,00h,00h,01h,01h,01h,00h,00h,00h,01h,01h,01h,00h,00h,01h,01h,01h,00h,00h,01h,01h,01h
db 00h,00h,01h,01h,01h,00h,00h,00h,01h,01h,01h,00h,00h,00h,01h,01h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 01h,01h,01h,00h,00h,01h,01h,01h,01h,01h,00h,00h,00h,00h,00h,00h,00h,01h,01h,01h,01h,01h,00h,00h,01h,01h,01h,00h,00h,01h,01h,01h
db 00h,00h,01h,01h,01h,00h,00h,00h,01h,01h,01h,01h,01h,01h,01h,01h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 01h,01h,01h,00h,00h,00h,00h,01h,01h,01h,00h,00h,00h,00h,01h,01h,01h,01h,01h,01h,01h,01h,00h,00h,01h,01h,01h,00h,00h,01h,01h,01h
db 00h,00h,01h,01h,01h,00h,00h,00h,01h,01h,01h,01h,01h,01h,01h,01h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 01h,01h,01h,00h,00h,00h,00h,01h,01h,01h,00h,00h,00h,01h,01h,01h,01h,00h,00h,01h,01h,01h,00h,00h,01h,01h,01h,00h,00h,01h,01h,01h
db 00h,00h,01h,01h,01h,00h,00h,00h,01h,01h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,01h,01h,01h,00h,00h,01h,01h,01h,01h,00h,00h,00h,01h,01h,01h,00h,00h,00h,01h,01h,01h,00h,00h,01h,01h,01h,00h,00h,01h,01h,01h
db 00h,00h,01h,01h,01h,00h,00h,00h,01h,01h,01h,01h,00h,00h,01h,01h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,01h,01h,01h,01h,01h,01h,01h,01h,01h,00h,00h,00h,01h,01h,01h,01h,01h,01h,01h,01h,01h,00h,00h,01h,01h,01h,00h,00h,01h,01h,01h
db 00h,00h,01h,01h,01h,00h,00h,00h,00h,01h,01h,01h,01h,01h,01h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,01h,01h,01h,01h,01h,00h,00h,00h,00h,00h,00h,01h,01h,01h,01h,00h,01h,01h,01h,00h,00h,01h,01h,01h,00h,00h,01h,01h,01h
db 00h,00h,01h,01h,01h,00h,00h,00h,00h,00h,01h,01h,01h,01h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h
db 011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h
db 011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,01h,01h,01h,01h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,0ah,0ah,0ah,0ah,0ah,0ah,0ah,0ah,0ah,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,01h,01h,01h,01h,01h,01h,01h
db 01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,0ah,013h,013h,013h,013h,013h,013h,013h,013h,013h,0ah,00h,00h,00h,00h,00h,00h,00h,00h,00h,01h,01h,01h,00h,00h,01h,01h
db 01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,0ah,013h,013h,013h,013h,013h,013h,013h,013h,013h,013h,013h,0ah,00h,00h,00h,00h,00h,00h,00h,01h,01h,01h,00h,00h,00h,00h,01h
db 01h,01h,00h,00h,01h,01h,01h,00h,00h,00h,01h,01h,01h,00h,00h,00h,00h,01h,01h,01h,01h,01h,00h,00h,00h,00h,01h,01h,01h,00h,01h,01h
db 00h,00h,00h,0ah,013h,013h,013h,013h,01h,01h,013h,013h,01h,01h,013h,013h,013h,0ah,00h,00h,00h,00h,00h,00h,01h,01h,01h,00h,00h,00h,00h,01h
db 01h,01h,00h,00h,00h,01h,01h,00h,00h,01h,01h,01h,00h,00h,00h,00h,01h,01h,01h,01h,01h,01h,01h,00h,00h,00h,01h,01h,01h,01h,01h,00h
db 00h,00h,00h,0ah,013h,013h,013h,013h,01h,01h,013h,013h,01h,01h,013h,013h,013h,0ah,00h,00h,00h,00h,00h,00h,01h,01h,01h,00h,00h,00h,00h,01h
db 01h,01h,00h,00h,00h,01h,01h,01h,00h,01h,01h,01h,00h,00h,00h,01h,01h,01h,00h,00h,00h,01h,01h,01h,00h,00h,01h,01h,01h,00h,00h,00h
db 00h,00h,00h,0ah,013h,013h,013h,013h,013h,013h,013h,013h,013h,013h,013h,013h,013h,0ah,00h,00h,00h,00h,00h,00h,01h,01h,01h,00h,00h,00h,00h,01h
db 01h,01h,00h,00h,00h,01h,01h,01h,00h,01h,01h,01h,00h,00h,00h,01h,01h,01h,01h,01h,01h,01h,01h,01h,00h,00h,01h,01h,01h,00h,00h,00h
db 00h,00h,00h,0ah,013h,013h,013h,013h,013h,013h,013h,013h,013h,013h,013h,013h,013h,0ah,00h,00h,00h,00h,00h,00h,01h,01h,01h,00h,00h,00h,00h,01h
db 01h,01h,00h,00h,00h,00h,01h,01h,00h,01h,01h,00h,00h,00h,00h,01h,01h,01h,01h,01h,01h,01h,01h,01h,00h,00h,01h,01h,01h,00h,00h,00h
db 00h,00h,00h,0ah,013h,013h,013h,013h,013h,013h,013h,013h,013h,013h,013h,013h,013h,0ah,00h,00h,00h,00h,00h,00h,01h,01h,01h,00h,00h,00h,00h,01h
db 01h,01h,00h,00h,00h,00h,01h,01h,00h,01h,01h,00h,00h,00h,00h,01h,01h,01h,00h,00h,00h,00h,00h,00h,00h,00h,01h,01h,01h,00h,00h,00h
db 00h,00h,00h,0ah,013h,013h,013h,013h,013h,01h,01h,01h,01h,013h,013h,013h,013h,0ah,00h,00h,00h,00h,00h,00h,00h,01h,01h,01h,00h,00h,01h,01h
db 01h,00h,00h,00h,00h,00h,01h,01h,01h,01h,01h,00h,00h,00h,00h,01h,01h,01h,01h,00h,00h,01h,01h,01h,00h,00h,01h,01h,01h,00h,00h,00h
db 00h,00h,00h,0ah,013h,013h,013h,013h,01h,013h,013h,013h,013h,01h,013h,013h,013h,0ah,00h,00h,00h,00h,00h,00h,00h,01h,01h,01h,01h,01h,01h,01h
db 01h,00h,00h,00h,00h,00h,00h,01h,01h,01h,00h,00h,00h,00h,00h,00h,01h,01h,01h,01h,01h,01h,01h,00h,00h,00h,01h,01h,01h,00h,00h,00h
db 00h,00h,00h,0ah,013h,013h,013h,013h,013h,013h,013h,013h,013h,013h,013h,013h,013h,0ah,00h,00h,00h,00h,00h,00h,00h,00h,00h,01h,01h,01h,01h,00h
db 00h,00h,00h,00h,00h,00h,00h,01h,01h,01h,00h,00h,00h,00h,00h,00h,00h,01h,01h,01h,01h,01h,00h,00h,00h,00h,01h,01h,01h,00h,00h,00h
db 00h,00h,00h,00h,0ah,013h,013h,013h,013h,013h,013h,013h,013h,013h,013h,013h,0ah,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,0ah,013h,013h,013h,013h,013h,013h,013h,013h,013h,0ah,00h,00h,00h,00h,00h,00h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h
db 011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h
db 00h,00h,00h,00h,00h,00h,0ah,0ah,0ah,0ah,0ah,0ah,0ah,0ah,0ah,00h,00h,00h,00h,00h,00h,00h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h
db 011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h,011h


sprite_logo     dw      128,32
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,0bh,0bh,0bh,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,0bh,0bh,0bh,0bh,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,0bh,016h,016h,016h,0bh,00h,00h,00h,00h,00h,00h,00h,00h,0bh,016h,016h,016h,0bh,0bh,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,05h,08h,08h,08h,00h
db 00h,00h,00h,00h,00h,00h,00h,0bh,016h,01ch,01dh,01dh,016h,00h,00h,00h,00h,00h,00h,00h,00h,016h,01ch,01dh,01dh,01ch,016h,0bh,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,05h,05h,04h,07h,08h,014h,00h
db 00h,00h,00h,00h,00h,00h,0bh,016h,01ch,01ch,01dh,01dh,01ch,016h,00h,00h,00h,00h,00h,00h,016h,01ch,01ch,01dh,01dh,01ch,01ch,016h,0bh,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,06h,06h,06h,06h,06h,06h,06h,06h,06h,06h,06h,00h,00h,00h,00h,00h,00h,00h,06h,06h,06h,06h,06h,06h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,05h,04h,08h,03h,07h,08h,013h,00h
db 00h,00h,00h,00h,00h,00h,0bh,016h,012h,012h,01ch,01ch,012h,016h,00h,00h,00h,00h,00h,00h,016h,012h,012h,01ch,01ch,012h,012h,016h,0bh,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,06h,06h,06h,06h,06h,06h,06h,06h,06h,06h,06h,06h,06h,00h,00h,00h,00h,00h,06h,06h,06h,06h,06h,06h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,05h,05h,08h,08h,08h,06h,04h,03h,05h,05h,05h,00h
db 00h,00h,00h,00h,00h,00h,00h,0bh,015h,015h,015h,015h,015h,00h,00h,00h,00h,00h,00h,00h,00h,016h,015h,015h,015h,015h,016h,0bh,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,06h,06h,06h,06h,06h,06h,06h,06h,06h,06h,06h,06h,06h,06h,00h,00h,00h,00h,06h,06h,06h,06h,06h,06h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,05h,04h,08h,011h,07h,08h,06h,04h,03h,05h,07h,08h,00h
db 00h,00h,00h,00h,00h,00h,00h,018h,018h,016h,016h,016h,016h,016h,016h,016h,016h,016h,018h,016h,016h,016h,016h,016h,016h,016h,016h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,06h,06h,06h,06h,06h,06h,06h,06h,06h,06h,06h,06h,06h,06h,06h,00h,00h,00h,06h,06h,06h,06h,06h,06h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,05h,04h,08h,06h,06h,07h,08h,06h,04h,03h,07h,08h,013h,00h
db 00h,00h,00h,00h,00h,00h,00h,016h,016h,016h,016h,016h,016h,016h,016h,016h,016h,016h,016h,016h,016h,016h,016h,016h,016h,016h,016h,016h,016h,016h,016h,016h
db 00h,00h,00h,00h,00h,00h,00h,06h,06h,06h,06h,06h,06h,06h,06h,06h,06h,06h,06h,06h,06h,06h,013h,014h,00h,06h,06h,06h,06h,06h,06h,00h
db 00h,00h,00h,00h,014h,013h,014h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,014h,013h,014h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,05h,04h,08h,06h,04h,04h,07h,04h,08h,06h,04h,03h,07h,08h,013h,00h
db 00h,00h,00h,01h,01h,01h,01h,01h,01h,01h,01h,01h,017h,019h,018h,019h,018h,018h,019h,019h,018h,019h,019h,019h,017h,016h,016h,016h,016h,018h,018h,017h
db 016h,00h,00h,00h,00h,00h,00h,06h,06h,06h,06h,06h,06h,00h,00h,00h,06h,06h,06h,06h,06h,06h,013h,013h,014h,06h,06h,06h,06h,06h,06h,00h
db 014h,00h,00h,014h,013h,013h,013h,014h,00h,00h,00h,00h,00h,00h,00h,00h,014h,00h,00h,014h,013h,013h,013h,014h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,014h,013h,014h,00h,00h,00h,00h,00h,00h,05h,04h,04h,08h,06h,08h,05h,05h,07h,04h,04h,08h,06h,04h,03h,05h,07h,08h,00h
db 00h,01h,01h,01h,01h,01h,01h,01h,01h,01h,01h,01h,01h,01h,01h,01h,01h,01h,01h,01h,01h,01h,01h,01h,01h,01h,01h,01h,01h,01h,01h,01h
db 01h,01h,00h,00h,00h,00h,00h,06h,06h,06h,06h,06h,06h,00h,00h,00h,06h,06h,06h,06h,06h,06h,014h,013h,013h,06h,06h,06h,06h,06h,06h,014h
db 013h,014h,00h,014h,013h,014h,013h,013h,014h,014h,00h,00h,00h,00h,00h,014h,013h,014h,00h,014h,013h,014h,013h,013h,014h,00h,00h,00h,00h,00h,00h,00h
db 014h,00h,00h,014h,013h,013h,013h,014h,00h,07h,07h,00h,05h,04h,08h,08h,04h,06h,08h,05h,07h,04h,04h,04h,08h,06h,04h,03h,04h,05h,05h,00h
db 01h,01h,01h,01h,01h,01h,01h,01h,01h,01h,01h,01h,01h,01h,01h,01h,01h,01h,01h,01h,01h,01h,01h,01h,01h,01h,01h,01h,01h,01h,01h,01h
db 01h,01h,01h,01h,01h,01h,00h,06h,06h,06h,06h,06h,06h,00h,00h,014h,06h,06h,06h,06h,06h,06h,00h,014h,013h,06h,06h,06h,06h,06h,06h,013h
db 013h,013h,014h,013h,014h,00h,014h,013h,013h,013h,014h,00h,00h,00h,014h,013h,013h,013h,014h,013h,014h,00h,014h,013h,013h,014h,00h,00h,00h,00h,00h,014h
db 013h,014h,00h,014h,013h,014h,013h,013h,014h,05h,09h,04h,08h,04h,010h,010h,04h,06h,08h,04h,04h,04h,04h,04h,08h,06h,04h,03h,05h,07h,08h,00h
db 01h,01h,01h,01h,017h,018h,019h,019h,019h,01h,01h,01h,018h,019h,018h,01h,01h,01h,01h,01h,01h,01h,01h,01h,01h,01h,01h,01h,01h,01h,01h,01h
db 01h,01h,01h,01h,00h,00h,00h,06h,06h,06h,06h,06h,06h,00h,014h,013h,06h,06h,06h,06h,06h,06h,00h,00h,014h,06h,06h,06h,06h,06h,06h,013h
db 014h,013h,013h,013h,014h,00h,00h,014h,013h,013h,013h,014h,00h,014h,013h,013h,014h,013h,013h,013h,014h,00h,00h,014h,013h,013h,014h,00h,00h,00h,014h,013h
db 013h,013h,014h,013h,014h,00h,014h,013h,013h,05h,09h,08h,010h,010h,010h,010h,04h,06h,08h,08h,08h,08h,08h,08h,08h,06h,04h,03h,07h,08h,013h,00h
db 00h,00h,00h,016h,016h,016h,018h,019h,019h,01h,01h,01h,016h,018h,018h,018h,018h,018h,018h,018h,018h,018h,018h,016h,01h,01h,01h,01h,018h,016h,016h,016h
db 00h,00h,00h,00h,00h,00h,00h,06h,06h,06h,06h,06h,06h,014h,013h,013h,06h,06h,06h,06h,06h,06h,00h,00h,00h,06h,06h,06h,06h,06h,06h,014h
db 00h,014h,013h,014h,00h,00h,00h,00h,014h,014h,013h,013h,014h,013h,013h,014h,00h,014h,013h,014h,00h,00h,00h,00h,014h,013h,013h,014h,00h,014h,013h,013h
db 014h,013h,013h,013h,014h,00h,00h,014h,013h,05h,09h,08h,08h,010h,010h,010h,04h,06h,08h,04h,04h,04h,04h,04h,08h,06h,04h,03h,07h,08h,014h,00h
db 00h,00h,00h,00h,00h,00h,016h,016h,018h,01h,01h,01h,016h,00h,00h,08h,05h,08h,00h,08h,05h,08h,00h,00h,01h,01h,01h,01h,017h,016h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,06h,06h,06h,06h,06h,06h,013h,013h,014h,06h,06h,06h,06h,06h,06h,00h,00h,00h,06h,06h,06h,06h,06h,06h,00h
db 00h,00h,014h,00h,00h,00h,00h,00h,00h,00h,014h,013h,013h,013h,014h,00h,00h,00h,014h,00h,00h,00h,00h,00h,00h,014h,013h,013h,014h,013h,013h,014h
db 00h,014h,013h,014h,00h,00h,00h,00h,014h,09h,07h,05h,05h,08h,08h,04h,04h,06h,08h,06h,04h,04h,04h,04h,08h,06h,04h,03h,07h,08h,013h,00h
db 00h,00h,00h,00h,00h,00h,00h,016h,017h,01h,01h,01h,016h,016h,00h,08h,05h,08h,00h,08h,05h,08h,00h,00h,01h,01h,01h,01h,017h,016h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,06h,06h,06h,06h,06h,06h,013h,014h,00h,06h,06h,06h,06h,06h,06h,00h,00h,00h,06h,06h,06h,06h,06h,06h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,014h,013h,014h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,014h,013h,013h,013h,014h,00h
db 00h,00h,014h,00h,00h,00h,00h,00h,00h,07h,07h,00h,00h,04h,04h,08h,06h,06h,08h,07h,04h,04h,07h,04h,08h,06h,04h,03h,05h,07h,08h,00h
db 00h,00h,00h,00h,00h,00h,00h,016h,017h,01h,01h,01h,017h,016h,00h,08h,05h,08h,00h,08h,05h,08h,00h,016h,016h,01h,01h,01h,017h,016h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,06h,06h,06h,06h,06h,06h,06h,06h,06h,06h,06h,06h,06h,06h,06h,00h,00h,00h,06h,06h,06h,06h,06h,06h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,014h,013h,014h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,05h,04h,04h,08h,06h,06h,04h,05h,07h,08h,06h,04h,03h,05h,05h,05h,00h
db 00h,00h,00h,00h,00h,00h,00h,016h,017h,01h,01h,01h,017h,016h,00h,08h,05h,08h,00h,08h,05h,08h,00h,016h,017h,01h,01h,01h,017h,016h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,06h,06h,06h,06h,06h,06h,06h,06h,06h,06h,06h,06h,06h,06h,06h,00h,00h,00h,06h,06h,06h,06h,06h,06h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,0ch,0ch,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,05h,04h,08h,08h,06h,06h,08h,06h,04h,03h,05h,07h,08h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,016h,01h,01h,01h,017h,016h,00h,08h,05h,08h,00h,08h,05h,08h,00h,016h,017h,01h,01h,01h,017h,016h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,0ch,0ch,0ch,0ch,0ch,0ch,0ch,0ch,06h,06h,06h,06h,06h,06h,00h,00h,00h,00h,06h,06h,06h,06h,06h,06h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,0ch,0ch,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,05h,04h,04h,08h,011h,08h,06h,04h,03h,07h,08h,013h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,016h,01h,01h,01h,017h,016h,00h,00h,08h,00h,00h,00h,08h,00h,00h,016h,017h,01h,01h,01h,017h,016h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,0ch,0ch,0ch,0ch,0ch,0ch,0ch,0ch,06h,06h,06h,06h,06h,06h,00h,00h,00h,00h,06h,06h,06h,06h,0ch,0ch,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,0ch,0ch,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,05h,05h,04h,08h,08h,06h,04h,03h,07h,08h,013h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,016h,01h,01h,01h,017h,016h,00h,00h,00h,00h,00h,00h,00h,00h,00h,016h,017h,01h,01h,01h,017h,016h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,06h,06h,06h,0ch,0ch,06h,06h,06h,06h,06h,06h,06h,00h,00h,00h,00h,00h,00h,06h,06h,06h,06h,0ch,0ch,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,0ch,0ch,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,05h,04h,04h,05h,07h,08h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,016h,01h,01h,01h,017h,016h,00h,00h,00h,00h,00h,00h,00h,00h,00h,016h,017h,01h,01h,01h,017h,016h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,06h,06h,06h,0ch,0ch,06h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,06h,06h,06h,06h,0ch,0ch,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,0ch,0ch,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,05h,05h,08h,08h,07h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,016h,01h,01h,01h,017h,016h,00h,00h,00h,00h,00h,00h,00h,00h,00h,016h,017h,01h,01h,01h,017h,016h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,06h,06h,06h,0ch,0ch,06h,00h,00h,00h,00h,0ch,0ch,00h,00h,0ch,0ch,0ch,00h,06h,0ch,0ch,0ch,0ch,0ch,0ch
db 0ch,0ch,00h,0ch,0ch,00h,00h,0ch,0ch,0ch,00h,00h,0ch,0ch,00h,00h,00h,00h,0ch,0ch,00h,00h,00h,00h,0ch,0ch,0ch,0ch,00h,0ch,0ch,00h
db 00h,00h,00h,0ch,0ch,0ch,0ch,0ch,00h,00h,00h,0ch,0ch,00h,00h,0ch,0ch,0ch,00h,00h,00h,00h,00h,00h,0ch,0ch,0ch,00h,04h,04h,08h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,016h,01h,01h,01h,017h,016h,00h,00h,00h,00h,00h,00h,00h,00h,00h,016h,017h,01h,01h,01h,017h,016h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,06h,06h,06h,0ch,0ch,06h,00h,00h,00h,00h,0ch,0ch,0ch,0ch,0ch,0ch,0ch,0ch,06h,0ch,0ch,0ch,0ch,0ch,0ch
db 0ch,0ch,00h,0ch,0ch,0ch,0ch,0ch,0ch,0ch,00h,00h,0ch,0ch,00h,00h,00h,00h,0ch,0ch,00h,00h,00h,0ch,0ch,0ch,0ch,0ch,0ch,0ch,0ch,00h
db 00h,00h,0ch,0ch,0ch,0ch,0ch,0ch,0ch,00h,00h,0ch,0ch,0ch,0ch,0ch,0ch,0ch,00h,00h,00h,0ch,0ch,0ch,0ch,0ch,0ch,00h,05h,05h,04h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,016h,01h,01h,01h,017h,016h,00h,00h,00h,00h,00h,00h,00h,00h,016h,017h,018h,01h,01h,01h,017h,016h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,06h,06h,06h,0ch,0ch,06h,00h,00h,00h,00h,0ch,0ch,0ch,0ch,00h,00h,0ch,0ch,06h,06h,06h,06h,0ch,0ch,00h
db 00h,00h,00h,0ch,0ch,0ch,00h,00h,0ch,0ch,00h,00h,0ch,0ch,00h,00h,00h,00h,0ch,0ch,00h,00h,00h,0ch,0ch,00h,00h,00h,0ch,0ch,0ch,00h
db 00h,0ch,0ch,0ch,00h,00h,00h,0ch,0ch,00h,00h,0ch,0ch,0ch,00h,00h,0ch,0ch,00h,00h,0ch,0ch,0ch,00h,00h,0ch,0ch,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,016h,016h,01h,01h,01h,016h,016h,00h,00h,00h,00h,00h,00h,00h,00h,016h,017h,019h,01h,01h,01h,017h,016h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,06h,06h,06h,0ch,0ch,06h,00h,00h,00h,00h,0ch,0ch,0ch,00h,00h,00h,0ch,0ch,06h,06h,06h,06h,0ch,0ch,00h
db 00h,00h,00h,0ch,0ch,00h,00h,00h,0ch,0ch,00h,00h,0ch,0ch,00h,00h,00h,00h,0ch,0ch,00h,00h,0ch,0ch,00h,00h,00h,00h,00h,0ch,0ch,00h
db 00h,0ch,0ch,00h,00h,00h,0ch,0ch,0ch,00h,00h,0ch,0ch,00h,00h,00h,0ch,0ch,00h,00h,0ch,0ch,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,016h,017h,01h,01h,01h,016h,015h,00h,00h,00h,00h,00h,00h,00h,00h,016h,017h,018h,01h,01h,01h,017h,016h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,06h,06h,06h,0ch,0ch,06h,00h,00h,00h,00h,0ch,0ch,00h,00h,00h,00h,0ch,0ch,06h,06h,06h,06h,0ch,0ch,00h
db 00h,00h,00h,0ch,0ch,00h,00h,00h,00h,00h,00h,00h,0ch,0ch,00h,00h,00h,00h,0ch,0ch,00h,00h,0ch,0ch,00h,00h,00h,00h,00h,0ch,0ch,00h
db 00h,0ch,0ch,00h,00h,0ch,0ch,0ch,00h,00h,00h,0ch,0ch,00h,00h,00h,00h,00h,00h,00h,0ch,0ch,0ch,0ch,0ch,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,016h,017h,01h,01h,01h,016h,00h,00h,00h,00h,00h,00h,00h,00h,00h,016h,017h,017h,01h,01h,01h,016h,016h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,06h,06h,06h,0ch,0ch,06h,00h,00h,00h,00h,0ch,0ch,00h,00h,00h,00h,0ch,0ch,06h,06h,06h,06h,0ch,0ch,00h
db 00h,00h,00h,0ch,0ch,00h,00h,00h,00h,00h,00h,00h,0ch,0ch,00h,00h,00h,00h,0ch,0ch,00h,00h,0ch,0ch,00h,00h,00h,00h,00h,0ch,0ch,00h
db 00h,0ch,0ch,0ch,0ch,0ch,0ch,00h,00h,00h,00h,0ch,0ch,00h,00h,00h,00h,00h,00h,00h,00h,00h,0ch,0ch,0ch,0ch,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,015h,016h,017h,01h,01h,01h,016h,00h,00h,00h,00h,00h,00h,00h,00h,015h,016h,016h,016h,01h,01h,01h,016h,015h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,06h,06h,06h,0ch,0ch,06h,00h,00h,00h,00h,0ch,0ch,00h,00h,00h,00h,0ch,0ch,06h,06h,06h,06h,0ch,0ch,00h
db 00h,00h,00h,0ch,0ch,00h,00h,00h,00h,00h,00h,00h,0ch,0ch,00h,00h,00h,00h,0ch,0ch,00h,00h,0ch,0ch,00h,00h,00h,00h,00h,0ch,0ch,00h
db 00h,0ch,0ch,0ch,0ch,00h,00h,00h,00h,00h,00h,0ch,0ch,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,0ch,0ch,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,015h,015h,00h,016h,01h,01h,01h,01h,016h,015h,00h,00h,00h,00h,00h,00h,015h,00h,00h,00h,01h,01h,01h,01h,016h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,06h,06h,06h,0ch,0ch,06h,00h,00h,00h,00h,0ch,0ch,00h,00h,00h,00h,0ch,0ch,06h,06h,06h,06h,0ch,0ch,00h
db 00h,00h,00h,0ch,0ch,00h,00h,00h,00h,00h,00h,00h,0ch,0ch,00h,00h,00h,00h,0ch,0ch,00h,00h,0ch,0ch,0ch,00h,00h,00h,0ch,0ch,0ch,00h
db 00h,0ch,0ch,0ch,00h,00h,00h,00h,0ch,00h,00h,0ch,0ch,00h,00h,00h,00h,00h,00h,00h,0ch,00h,00h,00h,00h,0ch,0ch,00h,00h,00h,00h,00h
db 00h,00h,00h,015h,00h,00h,00h,00h,01h,01h,01h,015h,00h,00h,015h,00h,00h,00h,00h,015h,00h,00h,00h,00h,01h,01h,01h,01h,00h,015h,015h,00h
db 00h,00h,00h,00h,00h,00h,00h,0ch,0ch,0ch,0ch,0ch,0ch,0ch,0ch,00h,00h,0ch,0ch,00h,00h,00h,00h,0ch,0ch,06h,06h,06h,06h,0ch,0ch,00h
db 00h,00h,00h,0ch,0ch,00h,00h,00h,00h,00h,00h,00h,0ch,0ch,0ch,0ch,0ch,0ch,0ch,0ch,00h,00h,00h,0ch,0ch,0ch,0ch,0ch,0ch,0ch,0ch,00h
db 00h,00h,0ch,0ch,0ch,0ch,0ch,0ch,0ch,00h,00h,0ch,0ch,00h,00h,00h,00h,00h,00h,00h,0ch,0ch,0ch,0ch,0ch,0ch,0ch,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,015h,00h,00h,00h,015h,00h,00h,00h,015h,00h,00h,00h,00h,00h,00h,00h,015h,00h,01h,01h,015h,00h,00h,00h,015h
db 00h,00h,00h,00h,00h,00h,00h,0ch,0ch,0ch,0ch,0ch,0ch,0ch,0ch,00h,00h,0ch,0ch,00h,00h,00h,00h,0ch,0ch,06h,06h,06h,06h,0ch,0ch,00h
db 00h,00h,00h,0ch,0ch,00h,00h,00h,00h,00h,00h,00h,00h,0ch,0ch,0ch,0ch,0ch,0ch,0ch,00h,00h,00h,00h,0ch,0ch,0ch,0ch,00h,0ch,0ch,00h
db 00h,00h,00h,0ch,0ch,0ch,0ch,00h,00h,00h,00h,0ch,0ch,00h,00h,00h,00h,00h,00h,00h,00h,0ch,0ch,0ch,0ch,0ch,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,015h,00h,00h,00h,00h,00h,015h,00h,00h,00h,00h,00h,00h,00h,00h,00h,015h,00h,00h,00h,00h,00h,015h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h


sprite_youwin   dw      128,32
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,01h,01h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 01h,01h,01h,01h,01h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,01h,01h,013h,013h,013h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,013h,013h,013h
db 01h,013h,013h,013h,013h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,01h,01h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,01h,00h,00h,00h,00h,00h,00h,00h,00h,01h,01h,013h,013h,013h,013h,013h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,01h,01h,013h
db 01h,013h,013h,013h,013h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,01h,01h,01h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,013h,01h,01h,01h,01h,00h,00h,00h,00h,00h,00h,01h,013h,013h,013h,013h,013h,013h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,01h,01h,01h
db 00h,00h,00h,01h,01h,01h,01h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,01h,01h,01h
db 01h,013h,013h,013h,013h,01h,00h,00h,00h,00h,00h,00h,00h,00h,01h,013h,013h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,013h,01h,013h,013h,013h,01h,00h,00h,00h,00h,00h,01h,013h,013h,013h,013h,013h,013h,01h,00h,00h,00h,00h,00h,00h,01h,01h,01h,013h,013h,01h
db 00h,00h,00h,01h,013h,013h,013h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,01h,01h,013h,01h
db 01h,013h,013h,013h,013h,01h,00h,00h,00h,00h,00h,00h,00h,00h,01h,013h,013h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 01h,00h,013h,013h,013h,013h,01h,00h,00h,00h,00h,01h,013h,013h,013h,013h,013h,013h,013h,01h,00h,00h,00h,00h,00h,01h,01h,00h,013h,013h,013h,01h
db 00h,00h,00h,01h,013h,013h,013h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,01h,013h,013h,01h
db 01h,013h,013h,013h,013h,01h,01h,00h,00h,00h,00h,00h,00h,01h,013h,013h,013h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 01h,00h,013h,013h,013h,013h,013h,01h,00h,00h,00h,01h,013h,013h,013h,013h,013h,013h,013h,01h,00h,00h,00h,00h,00h,01h,013h,013h,013h,013h,013h,01h
db 00h,00h,00h,01h,013h,013h,013h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,01h,01h,013h,013h,01h
db 01h,013h,013h,013h,013h,013h,01h,00h,00h,00h,00h,00h,01h,013h,013h,013h,013h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,01h,013h,013h,013h,013h,013h,01h,00h,00h,01h,013h,013h,013h,013h,013h,013h,013h,013h,01h,00h,00h,00h,00h,00h,01h,013h,013h,013h,013h,013h,01h
db 00h,00h,00h,01h,00h,00h,00h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,01h,013h,013h,013h,01h
db 01h,013h,013h,013h,013h,013h,01h,00h,00h,00h,00h,01h,00h,013h,013h,013h,013h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,01h,01h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,01h,013h,013h,013h,013h,013h,013h,01h,00h,01h,013h,013h,013h,013h,013h,013h,013h,013h,01h,00h,00h,00h,01h,01h,013h,013h,013h,013h,013h,013h,01h
db 00h,00h,00h,01h,01h,01h,01h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,01h,013h,013h,013h,013h,01h
db 01h,01h,013h,013h,013h,013h,01h,00h,00h,00h,00h,01h,013h,013h,013h,013h,013h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,01h,00h,00h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,01h,013h,013h,013h,013h,013h,013h,01h,00h,01h,013h,013h,013h,013h,013h,013h,013h,013h,01h,00h,00h,00h,01h,013h,013h,013h,013h,013h,013h,013h,01h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,01h,01h,01h,01h,01h,01h,01h,00h,00h,00h,00h,00h,01h,01h,013h,013h,013h,013h,01h
db 00h,01h,013h,013h,013h,013h,00h,01h,00h,00h,01h,01h,013h,013h,013h,013h,013h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,01h,00h,00h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,01h,013h,013h,013h,013h,013h,013h,01h,00h,01h,013h,013h,01h,013h,013h,013h,013h,013h,01h,00h,00h,01h,013h,013h,013h,013h,013h,013h,013h,013h,01h
db 00h,00h,00h,00h,01h,01h,01h,00h,00h,00h,00h,01h,01h,013h,013h,013h,013h,013h,013h,013h,01h,01h,01h,00h,00h,01h,013h,013h,013h,013h,013h,01h
db 00h,00h,01h,013h,013h,013h,013h,01h,00h,00h,01h,013h,013h,013h,013h,013h,01h,01h,00h,00h,00h,00h,01h,01h,01h,01h,01h,01h,01h,01h,01h,01h
db 00h,00h,00h,00h,00h,01h,01h,01h,013h,00h,00h,00h,00h,00h,00h,01h,013h,013h,013h,013h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,01h,013h,013h,013h,013h,013h,013h,01h,00h,01h,013h,013h,01h,013h,013h,013h,013h,013h,01h,00h,00h,01h,013h,013h,013h,013h,013h,013h,013h,01h,00h
db 00h,00h,00h,01h,01h,013h,01h,00h,00h,00h,01h,00h,013h,013h,013h,013h,013h,013h,013h,013h,013h,013h,01h,00h,00h,01h,013h,013h,013h,013h,013h,01h
db 00h,00h,01h,01h,013h,013h,013h,00h,01h,00h,01h,013h,013h,013h,013h,013h,01h,00h,00h,00h,00h,01h,01h,013h,013h,013h,013h,013h,013h,013h,013h,01h
db 01h,00h,00h,00h,00h,01h,013h,01h,01h,01h,00h,00h,00h,00h,00h,01h,013h,013h,013h,013h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,01h,013h,013h,013h,013h,013h,013h,01h,01h,013h,013h,013h,01h,013h,013h,013h,013h,013h,01h,00h,00h,01h,013h,013h,013h,013h,013h,00h,01h,00h,00h
db 00h,00h,01h,01h,013h,013h,01h,00h,00h,01h,01h,00h,013h,013h,013h,013h,013h,013h,013h,013h,013h,013h,01h,013h,00h,01h,01h,013h,013h,013h,013h,01h
db 00h,00h,00h,01h,01h,013h,013h,013h,01h,00h,01h,013h,013h,013h,013h,01h,01h,00h,00h,00h,01h,01h,013h,013h,013h,013h,013h,013h,013h,013h,013h,013h
db 01h,00h,00h,00h,00h,01h,013h,013h,013h,01h,01h,00h,00h,00h,00h,01h,013h,013h,013h,013h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,01h,013h,013h,013h,013h,013h,013h,013h,01h,013h,013h,013h,01h,013h,013h,013h,013h,013h,01h,00h,00h,01h,013h,013h,013h,013h,013h,01h,01h,00h,00h
db 00h,00h,01h,013h,013h,013h,01h,00h,00h,00h,01h,00h,013h,013h,013h,013h,013h,013h,013h,013h,013h,013h,01h,013h,00h,00h,01h,01h,013h,013h,013h,01h
db 00h,00h,00h,00h,01h,013h,013h,013h,00h,01h,01h,013h,013h,013h,013h,01h,00h,00h,00h,00h,01h,013h,013h,013h,013h,013h,01h,01h,01h,013h,013h,013h
db 013h,01h,00h,00h,00h,01h,013h,013h,013h,00h,01h,00h,00h,00h,00h,01h,013h,013h,013h,013h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,01h,013h,013h,013h,013h,013h,013h,013h,01h,013h,013h,013h,01h,013h,013h,013h,013h,013h,01h,00h,00h,01h,013h,013h,013h,013h,01h,00h,00h,00h,00h
db 00h,00h,01h,013h,013h,013h,01h,00h,00h,00h,01h,00h,013h,013h,013h,013h,013h,013h,013h,013h,013h,013h,01h,013h,013h,00h,00h,01h,013h,013h,013h,01h
db 00h,00h,00h,00h,01h,013h,013h,013h,013h,01h,01h,013h,013h,013h,013h,01h,00h,00h,00h,00h,01h,013h,013h,013h,00h,01h,01h,00h,01h,01h,013h,013h
db 013h,01h,00h,00h,00h,01h,013h,013h,013h,00h,01h,00h,00h,00h,00h,01h,013h,013h,013h,013h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,01h,013h,013h,013h,013h,013h,013h,013h,01h,013h,013h,013h,01h,013h,013h,013h,013h,013h,01h,00h,00h,01h,013h,013h,013h,013h,01h,00h,00h,00h,00h
db 00h,00h,01h,013h,013h,013h,01h,00h,00h,00h,01h,00h,013h,013h,013h,013h,01h,01h,01h,01h,013h,013h,013h,01h,013h,00h,00h,01h,013h,013h,013h,01h
db 00h,00h,00h,00h,01h,01h,01h,013h,013h,013h,013h,013h,013h,013h,013h,01h,00h,00h,00h,00h,01h,013h,013h,013h,00h,01h,00h,00h,00h,01h,00h,013h
db 013h,01h,00h,00h,00h,01h,013h,013h,013h,00h,01h,00h,00h,00h,00h,01h,013h,013h,013h,013h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,01h,013h,013h,013h,013h,013h,013h,013h,01h,013h,013h,013h,01h,013h,013h,013h,013h,013h,01h,00h,00h,01h,013h,013h,013h,00h,01h,00h,00h,00h,00h
db 00h,00h,01h,013h,013h,013h,01h,00h,00h,00h,01h,00h,013h,013h,013h,013h,01h,00h,00h,01h,013h,013h,013h,01h,013h,00h,00h,00h,01h,013h,013h,01h
db 00h,00h,00h,00h,00h,00h,01h,013h,013h,013h,013h,013h,013h,013h,013h,01h,00h,00h,00h,00h,01h,013h,013h,013h,01h,00h,00h,00h,00h,01h,00h,013h
db 013h,01h,00h,00h,00h,01h,013h,013h,013h,00h,01h,00h,00h,00h,00h,01h,013h,013h,013h,013h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,01h,013h,013h,013h,013h,013h,013h,013h,013h,013h,013h,013h,01h,013h,013h,013h,013h,013h,01h,00h,01h,00h,013h,013h,013h,01h,00h,00h,00h,00h,00h
db 00h,00h,01h,013h,013h,013h,01h,00h,00h,00h,00h,01h,013h,013h,013h,013h,01h,00h,00h,01h,013h,013h,013h,01h,013h,00h,00h,00h,01h,013h,013h,01h
db 00h,00h,00h,00h,00h,00h,00h,01h,013h,013h,013h,013h,013h,013h,013h,01h,00h,00h,00h,00h,01h,013h,013h,013h,01h,00h,00h,00h,00h,01h,00h,013h
db 013h,01h,00h,00h,00h,01h,013h,013h,013h,00h,01h,00h,00h,00h,00h,01h,013h,013h,013h,013h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,01h,013h,013h,013h,013h,013h,013h,013h,013h,013h,013h,013h,01h,013h,013h,013h,013h,013h,01h,01h,01h,00h,013h,013h,013h,01h,00h,00h,00h,00h,00h
db 00h,00h,01h,013h,013h,013h,01h,00h,00h,00h,00h,01h,013h,013h,013h,013h,01h,00h,00h,01h,013h,013h,013h,01h,013h,00h,00h,00h,01h,013h,013h,01h
db 00h,00h,00h,00h,00h,00h,01h,01h,013h,013h,013h,013h,013h,013h,013h,01h,00h,00h,00h,00h,01h,013h,013h,013h,01h,00h,00h,00h,00h,01h,00h,013h
db 013h,01h,00h,00h,00h,01h,013h,013h,013h,00h,01h,00h,00h,00h,01h,00h,013h,013h,013h,013h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,01h,013h,013h,013h,013h,013h,013h,013h,013h,013h,00h,01h,013h,013h,013h,013h,013h,01h,01h,00h,013h,013h,013h,01h,00h,00h,00h,00h,00h,00h
db 00h,00h,01h,013h,013h,013h,01h,00h,00h,00h,00h,01h,013h,013h,013h,00h,01h,00h,00h,01h,013h,013h,013h,01h,013h,00h,00h,00h,01h,01h,01h,013h
db 00h,00h,00h,00h,01h,01h,013h,013h,013h,013h,013h,013h,013h,013h,01h,01h,00h,00h,00h,00h,01h,013h,013h,013h,01h,01h,00h,00h,00h,01h,00h,013h
db 013h,01h,00h,00h,00h,01h,013h,013h,013h,00h,01h,00h,00h,00h,01h,00h,013h,013h,013h,013h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,01h,01h,01h,013h,013h,013h,013h,013h,013h,00h,01h,013h,013h,013h,013h,013h,01h,01h,00h,013h,013h,013h,01h,00h,00h,00h,00h,00h,00h
db 00h,00h,01h,013h,013h,013h,01h,00h,00h,00h,00h,01h,013h,013h,013h,00h,01h,00h,00h,01h,013h,013h,013h,01h,013h,00h,00h,00h,00h,01h,01h,013h
db 00h,00h,00h,00h,01h,013h,013h,013h,013h,013h,013h,01h,01h,01h,01h,00h,00h,00h,00h,00h,01h,013h,013h,013h,013h,01h,01h,01h,01h,01h,00h,013h
db 01h,013h,00h,00h,00h,01h,013h,013h,013h,00h,01h,00h,00h,00h,01h,00h,013h,013h,013h,013h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,01h,013h,013h,013h,013h,013h,00h,00h,01h,013h,013h,013h,013h,013h,013h,00h,013h,013h,013h,01h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,01h,013h,013h,013h,01h,00h,00h,00h,00h,01h,013h,013h,013h,00h,01h,00h,00h,01h,013h,013h,013h,01h,013h,00h,00h,00h,00h,013h,013h,013h
db 00h,00h,00h,01h,01h,013h,013h,013h,013h,013h,01h,01h,00h,00h,00h,00h,00h,00h,00h,00h,01h,01h,013h,013h,013h,013h,013h,013h,013h,013h,013h,013h
db 01h,00h,00h,00h,00h,01h,013h,013h,013h,00h,01h,01h,00h,00h,01h,00h,013h,013h,013h,013h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,01h,01h,013h,013h,013h,013h,00h,01h,01h,013h,013h,013h,013h,013h,013h,00h,013h,013h,01h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,01h,013h,013h,01h,00h,00h,00h,00h,01h,013h,013h,013h,00h,01h,00h,00h,01h,013h,013h,013h,01h,013h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,01h,013h,013h,013h,013h,013h,013h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,01h,013h,013h,013h,013h,013h,013h,013h,013h,013h,01h
db 01h,00h,00h,00h,00h,01h,013h,013h,013h,00h,00h,00h,01h,01h,01h,00h,013h,013h,013h,013h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,01h,013h,013h,013h,00h,01h,00h,01h,013h,013h,013h,013h,013h,013h,013h,013h,01h,013h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,01h,013h,013h,01h,00h,00h,00h,00h,01h,013h,013h,013h,01h,00h,00h,00h,01h,013h,013h,013h,01h,013h,00h,00h,00h,00h,01h,01h,00h
db 00h,00h,00h,01h,013h,013h,013h,013h,013h,013h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,01h,013h,013h,013h,013h,013h,013h,013h,013h,01h,01h
db 00h,00h,00h,00h,00h,01h,013h,013h,013h,013h,013h,013h,013h,013h,013h,013h,013h,013h,013h,013h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,01h,013h,013h,01h,01h,00h,00h,00h,01h,013h,013h,013h,013h,013h,013h,013h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,01h,013h,013h,01h,00h,00h,00h,00h,01h,013h,013h,013h,01h,00h,00h,00h,01h,013h,013h,013h,01h,013h,00h,00h,00h,00h,01h,013h,01h
db 00h,00h,00h,01h,013h,013h,013h,013h,013h,013h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,01h,01h,01h,01h,01h,01h,01h,01h,01h,00h
db 00h,00h,00h,00h,00h,01h,013h,013h,013h,013h,013h,013h,013h,013h,013h,013h,013h,013h,013h,013h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,01h,013h,01h,013h,00h,00h,00h,00h,00h,01h,01h,01h,01h,013h,013h,01h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,01h,013h,013h,01h,00h,00h,00h,00h,01h,013h,013h,01h,00h,00h,00h,00h,01h,013h,013h,013h,01h,013h,00h,00h,00h,00h,01h,013h,01h
db 00h,00h,00h,01h,013h,013h,013h,013h,013h,01h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,013h,013h,013h,013h,013h,00h,00h,00h
db 00h,00h,00h,00h,00h,01h,013h,013h,013h,013h,013h,013h,013h,013h,013h,013h,013h,013h,013h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,01h,01h,013h,013h,00h,00h,00h,00h,00h,00h,00h,00h,01h,01h,01h,013h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,01h,013h,013h,01h,00h,00h,00h,00h,01h,01h,01h,013h,00h,00h,00h,00h,01h,01h,013h,01h,01h,013h,00h,00h,00h,00h,01h,01h,01h
db 00h,00h,00h,01h,01h,013h,013h,00h,01h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,01h,013h,013h,013h,013h,013h,013h,013h,013h,013h,013h,013h,013h,01h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,013h,013h,013h,013h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,01h,01h,00h,00h,00h,00h,00h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,01h,01h,00h,00h,00h,00h,00h,00h,00h,01h,01h
db 00h,00h,00h,00h,01h,01h,01h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,01h,01h,013h,013h,013h,013h,013h,013h,013h,013h,013h,013h,013h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,01h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,01h,01h,01h,01h,01h,01h,01h,01h,01h,01h,01h,01h,01h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h
db 00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h




; color palette
palette_totalcolors     equ     31
palette db 5,5,25
db 0,0,0
db 255, 255, 255
db 240, 240, 240
db 220, 220, 220
db 200, 200, 200
db 180, 180, 180
db 160, 160, 160
db 140, 140, 140
db 120, 120, 120
db 100, 100, 100
db 80, 80, 80
db 40, 40, 40
db 20, 20, 20
db 0,0,0
db 0,0,0
db 179, 198, 245
db 145, 235, 160
db 252, 29, 18
db 235, 255, 9
db 167,172,34
db 31, 50, 30
db 46, 75, 45
db 62, 100, 60
db 77, 125, 75
db 93, 150, 90
db 114, 169, 111
db 138, 184, 136
db 242, 192, 192
db 107, 91, 3
db 0,0,0
db 0,0,0
db 0,0,0
db 0,0,0
db 0,0,0
db 0,0,0
db 0,0,0
db 0,0,0
db 0,0,0

; variables for video routines
videobuffer             dw 0




ship_x          dw      100
ship_y          dw      100
ship_stat       dw      1

pi_MAX          equ     10
pi_x            dw      pi_MAX dup(0)
pi_y            dw      pi_MAX dup(0)
pi_stat         dw      pi_MAX dup(0)
pi_speed        dw      pi_MAX dup(0)
pi_deadtime     dw      pi_MAX dup(0)
pi_sway         dw      pi_MAX dup(0)
pi_xdir         dw      pi_MAX dup(0)


shots_MAX       equ     10
shots_x         dw      0,shots_MAX dup(0)
shots_y         dw      0,shots_MAX dup(0)
shots_stat      dw      0,shots_MAX dup(0)

stars_MAX       equ     100
star_x          dw      1,2,3,stars_MAX dup(0)
star_y          dw      1,2,3,stars_MAX dup(0)
star_bright     dw      1,2,3,stars_MAX dup(0)
star_speed      dw      1,2,3,stars_MAX dup(0)

gameover        dw      -1
gamestart       dw      0
haswon          dw      0


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.code

.startup
EntryPoint:
        call    InitGraphics
TitleScreen:
        call    ClearScreen

        repeat5:
        call    GetKeyPress
        cmp     ah,0
        jne      repeat5

        mov     ax,96
        mov     bx,50
        lea     si,sprite_logo
        call    DrawSprite

        mov     ax,gameover
        cmp     ax,-1
        je      TitleScreen_skip1
        mov     ax,126
        mov     bx,100
        lea     si,sprite_gameover
        call    DrawSprite
        TitleScreen_skip1:

        call    DoVideo
        mov     ah,10h
        mov     al,10h
        mov     bx,0
        mov     ch,0ffh
        mov     cl,0ffh
        mov     dh,0ffh
        int     10h
        repeat:
        call    GetKeyPress
        cmp     ah,0
        je      repeat
        mov     ch,0000111111b
        repeat2:
        DoVideo_cycle1_a:
        mov     dx,03dah
        in      al,dx
        and     al,01h
        cmp     al,0
        jne     DoVideo_cycle1_a

        mov     cl,ch
        mov     dh,ch
        mov     ah,10h
        mov     al,10h
        mov     bx,0
        int     10h
        sub     ch,2
        cmp     ch,0
        jg      repeat2
        mov     ah,10h
        mov     al,10h
        mov     bx,0
        mov     ch,3
        mov     cl,2
        mov     dh,2
        int     10h


        mov     ax,120
        mov     ship_x,ax
        mov     ax,90
        mov     ship_y,ax
        mov     cx,stars_MAX
        lea     bp,star_y
        call    ClearWords
        mov     cx,pi_MAX
        lea     bp,pi_stat
        call    ClearWords
        mov     cx,shots_MAX
        lea     bp,shots_stat
        call    ClearWords
        mov     ax,0
        mov     gameover,ax
        mov     ax,100
        mov     gamestart,ax
        mov     ax,0
        mov     haswon,ax


        call    Random_seed
        call    StarField_Init
        jmp     GameLoop
ExitPoint:
        mov ah,00h
        mov al,03h
        int 10h        
        mov ax,4C00h            ; return to DOS
        int 21h

GameLoop:

        call    Check_HasWon
        call    Shots_Update
        call    ProcessKeys
        call    StarField_Update

        mov     ax,haswon
        cmp     ax,1
        je      GameLoop_skip
        mov     ax,gamestart
        cmp     ax,0
        je      GameLoop_Updates
        dec     ax
        mov     gamestart,ax
        jmp     GameLoop_skip

        GameLoop_Updates:
        call    Pi_Update
        call    Shots_DetectCollision

        mov     ax,gameover
        cmp     ax,0
        je      GameLoop_skip

        inc     ax
        mov     gameover,ax
        cmp     ax,100
        ja      TitleScreen

        GameLoop_skip:


        call    ClearScreen
        call    StarField_Draw
        call    RedrawSprites

        mov     ax,haswon
        cmp     ax,1
        jne     GameLoop_skip2

        mov     ax,120
        mov     bx,90
        lea     si,sprite_youwin
        call    DrawSprite

        GameLoop_skip2:

        call    DoVideo
        jmp     GameLoop
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


ClearWords      proc
        pusha
        mov     al,0
        ClearWords_Loop:
        mov     [bp],al
        add     bp,2
        loop    ClearWords_Loop
        popa
        ret
ClearWords      endp


Check_HasWon    proc
        pusha
        mov     cx,pi_max
        mov     si,0
        Check_HasWon_Pi_Loop:
        mov     ax,pi_stat[si]
        cmp     ax,2
        jne     Check_HasWon_ret
        add     si,2
        loop    Check_HasWon_Pi_Loop
        mov     ax,1
        mov     haswon,ax

        Check_HasWon_ret:
        popa
        ret
Check_HasWon    endp


Shots_DetectCollision   proc
        pusha
        mov     cx,pi_max
        mov     si,0
        Shots_DetectCollision_Pi_Loop:
        push    cx

        mov     ax,pi_stat[si]
        cmp     ax,0
        je      Shots_DetectCollision_Pi_Next

        mov     bp,0
        mov     cx,shots_MAX

        Shots_DetectCollision_Shot_Loop:
        push    cx

        mov     ax,shots_stat[bp]
        cmp     ax,0
        je     Shots_DetectCollision_Shot_Next

        mov     ax,shots_x[bp]
        add     ax,4
        mov     bx,pi_x[si]
        cmp     ax,bx
        jl      Shots_DetectCollision_Shot_Next
        add     bx,32
        cmp     ax,bx
        jg      Shots_DetectCollision_Shot_Next
        mov     ax,shots_y[bp]
        sub     ax,20
        mov     bx,pi_y[si]
        cmp     ax,bx
        jg      Shots_DetectCollision_Shot_Next
        add     ax,12
        cmp     ax,bx
        jl      Shots_DetectCollision_Shot_Next

        mov     ax,pi_stat[si]
        cmp     ax,1
        je      Shots_DetectCollision_Shot_KiledPi

        Shots_DetectCollision_Shot_HitDeadPi:

        mov     ax,pi_y[si]
        sub     ax,2
        mov     pi_y[si],ax
        mov     ax,pi_speed[si]
        sub     ax,1
        mov     pi_speed[si],ax
        mov     ax,0
        mov     shots_stat[bp],ax
        jmp     Shots_DetectCollision_Shot_Next

        Shots_DetectCollision_Shot_KiledPi:
        mov     ax,2
        mov     pi_stat[si],ax
        mov     ax,5000
        mov     pi_deadtime[si],ax
        mov     ax,0
        mov     shots_stat[bp],ax
        mov     bx,pi_speed[si]
        mov     ax,4
        sub     ax,bx
        mov     dx,15
        mul     dx
        mov     bx,ax
        mov     ax,pi_y[si]
        sub     ax,bx
        mov     pi_y[si],ax
        mov     ax,pi_speed[si]
        neg     ax
        add     ax,1
        cmp     ax,0
        jne     Shots_Collision_Shot_PiHit_ChangeSpeed_1
        add     ax,1
        Shots_Collision_Shot_PiHit_ChangeSpeed_1:
        mov     pi_speed[si],ax
        Shots_DetectCollision_Shot_Next:

        add     bp,2
        pop     cx
        dec     cx
        cmp     cx,0
        ja      Shots_DetectCollision_Shot_Loop

        Shots_DetectCollision_Pi_Next:
        pop     cx
        add     si,2
        dec     cx
        cmp     cx,0
        ja    Shots_DetectCollision_Pi_Loop
        popa
Shots_DetectCollision   endp



Pi_DetectCollision   proc
        pusha
        mov     cx,pi_max
        mov     si,0
        Pi_DetectCollision_Pi_Loop:
        push    cx

        mov     ax,pi_stat[si]
        cmp     ax,0
        je      Pi_DetectCollision_Pi_Next
        cmp     ax,2
        je      Pi_DetectCollision_Pi_Next
        mov     bp,0
        mov     cx,Pi_MAX

        Pi_DetectCollision_Pi2_Loop:
        push    cx

        mov     ax,pi_stat[bp]
        cmp     ax,2
        jne     Pi_DetectCollision_Pi2_Next
        mov     ax,pi_speed[bp]
        cmp     ax,0
        jne     Pi_DetectCollision_Pi2_Next

        mov     ax,pi_x[bp]
        mov     bx,pi_x[si]
        sub     ax,16+8
        add     bx,16
        cmp     bx,ax
        jl      Pi_DetectCollision_Pi2_Next
        add     ax,32+16+8+8
        cmp     bx,ax
        jg      Pi_DetectCollision_Pi2_Next
        mov     ax,pi_y[bp]
        mov     bx,pi_y[si]
        cmp     ax,bx
        jg      Pi_DetectCollision_Pi2_Next
        add     ax,32
        cmp     ax,bx
        jl      Pi_DetectCollision_Pi2_Next


        mov     ax,pi_speed[si]
        cmp     ax,2
        jge     Pi_DetectCollision_Pi__Fast

        mov     ax,pi_y[bp]
        add     ax,1
        mov     pi_y[bp],ax
        call    Random
        sub     ax,5
        mov     bx,pi_x[bp]
        add     bx,ax
        mov     pi_x[bp],bx
        jmp     Pi_DetectCollision_Pi2_Next

        Pi_DetectCollision_Pi__Fast:
        

        mov     ax,pi_y[bp]
        add     ax,25
        mov     pi_y[bp],ax
        mov     ax,-1
        mov     pi_speed[si],ax
        

        Pi_DetectCollision_Pi2_Next:
        add     bp,2
        pop     cx
        dec     cx
        cmp     cx,0
        ja      Pi_DetectCollision_Pi2_Loop

        Pi_DetectCollision_Pi_Next:
        pop     cx
        add     si,2
        dec     cx
        cmp     cx,0
        ja    Pi_DetectCollision_Pi_Loop
        popa
Pi_DetectCollision   endp





Pi_Update       proc
        pusha
        mov     cx,pi_max
        mov     bp,0
        Pi_Update_loop:
        mov     ax,pi_stat[bp]
        cmp     ax,2
        jne     Pi_Update_regular
        mov     ax,pi_deadtime[bp]
        dec     ax
        mov     pi_deadtime[bp],ax
        cmp     ax,0
        jl      Pi_Update_RevivePi

        Pi_Update_regular:
        mov     ax,pi_stat[bp]
        cmp     ax,2
        jne     Pi_Update_nondead
        mov     ax,pi_y[bp]
        cmp     ax,190
        jg      Pi_Update_newpi

        Pi_Update_nondead:

        mov     ax,pi_stat[bp]
        cmp     ax,0
        je      Pi_Update_newpi
        mov     ax,pi_y[bp]
        mov     bx,pi_speed[bp]
        add     ax,bx
        mov     pi_y[bp],ax        
        cmp     ax,200
        jg      Pi_Update_newpi
        cmp     ax,-100
        jl      Pi_Update_newpi

         ;;; to be implemented later
        ;mov     ax,pi_xdir[bp]
        ;mov     bx,pi_x[bp]
        ;add     bx,ax
        ;mov     pi_x[bp],bx
        ;cmp     ax,0
        ;jnl     Pi_Update_sway_next1
        ;mov     ax,pi_xdir[bp]
        ;neg     ax
        ;mov     pi_xdir[bp],ax
        ;mov     ax,1
        ;mov     pi_x[bp],ax
        ;Pi_Update_sway_next1:
        ;mov     ax,pi_x[bp]
        ;cmp     ax,320
        ;jng     Pi_Update_sway_next2
        ;mov     ax,pi_xdir[bp]
        ;neg     ax
        ;mov     pi_xdir[bp],ax
        ;mov     ax,319
        ;mov     pi_x[bp],ax
        ;Pi_Update_sway_next2:


        Pi_Update_Ship_DetectCollision:
        mov     ax,ship_x
        add     ax,15
        mov     bx,pi_x[bp]
        sub     bx,15
        cmp     ax,bx
        jl      Pi_Update_loop_continue
        add     bx,15+15+32
        cmp     ax,bx
        jg      Pi_Update_loop_continue
        mov     ax,ship_y
        add     ax,5
        mov     bx,pi_y[bp]
        cmp     ax,bx
        jl      Pi_Update_loop_continue
        add     bx,32
        cmp     ax,bx
        jg      Pi_Update_loop_continue
        mov     ax,ship_y
        mov     bx,pi_speed[bp]
        cmp     bx,0
        jl      Pi_Update_loop_continue
        shl     bx,1
        add     ax,bx
        mov     ship_y,ax
        cmp     ax,205
        jl      Pi_Update_loop_continue
        mov     ax,1
        mov     gameover,ax

        Pi_Update_loop_continue:
        add     bp,2
        dec     cx
        cmp     cx,0
        ja      Pi_Update_loop

        popa
        ret

        Pi_Update_newpi:
        call     Random
        mov      bx,32
        mul      bx
        sub      ax,32+5
        mov      pi_x[bp],ax
        call    Random
        sub     ax,50
        mov     pi_y[bp],ax
        call    Random
        mov     dl,4
        idiv    dl
        mov     pi_speed[bp],ax
        call    Random
        sub     ax,5
        mov     pi_xdir[bp],ax
        mov     ax,1
        mov     pi_stat[bp],ax

        popa
        ret

        Pi_Update_RevivePi:
        mov     ax,1
        mov     pi_stat[bp],ax
        mov     ax,1
        mov     pi_speed[bp],ax
        popa
        ret
Pi_Update       endp

StarField_Draw          proc
        pusha

        mov     cx,stars_MAX
        mov     bp,0
StarField_Draw_loop:
        mov     ax,star_x[bp]
        mov     bx,star_y[bp]
        mov     dx,star_bright[bp]
        add     dx,3
        call    DrawPixel
        add     bp,2
        loop    StarField_Draw_loop

        popa
        ret
StarField_Draw          endp

StarField_Update        proc
        pusha
        mov     cx,stars_MAX
        mov     bp,0
StarField_Update_loop:
        mov     ax,star_y[bp]
        mov     bx,star_speed[bp]
        add     ax,bx
        mov     star_y[bp],ax
        cmp     ax,200
        jg      StarField_Update_newstar
        StarField_Update_continue:
        add     bp,2
        loop    StarField_Update_loop
        popa
        ret

        StarField_Update_newstar:
        mov     ax,gameover
        cmp     ax,0
        ja     StarField_Update_continue

        call     Random
        mov      bx,32
        mul      bx
        mov      bx,cx
        sub      bx,65
        add      ax,bx
        mov      star_x[bp],ax

        call    Random
        mov     star_speed[bp],ax

        call    Random
        mov     star_bright[bp],ax

        mov     ax,0
        mov     star_y[bp],ax
        jmp     StarField_Update_continue        
StarField_Update        endp


StarField_Init  proc
        pusha
        mov     cx,stars_MAX
        mov     bp,0
StarField_Init_loop:
        call     Random
        mov      bx,32
        mul      bx
        mov      bx,cx
        sub      bx,65
        add      ax,bx
        mov      star_x[bp],ax

        call    Random
        mov     star_y[bp],ax

        call    Random
        mov     star_speed[bp],ax

        call    Random
        mov     star_bright[bp],ax

        add     bp,2
        loop    StarField_Init_loop

        popa
        ret
StarField_Init  endp


Shots_Fire      proc
        pusha
        mov     bp,0
        mov     cx,shots_MAX
Shots_Fire_loop:
        mov     ax,shots_stat[bp]
        cmp     ax,0
        jne     Shots_Fire_next
        mov     ax,ship_x
        add     ax,(35/2)-(8/2)
        mov     bx,ship_y
        mov     shots_x[bp],ax                       
        mov     shots_y[bp],bx
        mov     ax,1
        mov     shots_stat[bp],ax
        popa
        ret
Shots_Fire_next:
        add     bp,2
        loop    Shots_Fire_loop
        popa
        ret        
Shots_Fire      endp

Shots_Update    proc
        pusha
        mov     bp,0
        mov     cx,shots_MAX
Shots_Update_loop:
        mov     ax,shots_stat[bp]
        cmp     ax,0
        jz      Shots_Update_next
        mov     ax,shots_y[bp]
        sub     ax,5
        cmp     ax,-32
        jl      Shots_Update_missedshot
        mov     shots_y[bp],ax
Shots_Update_next:
        add     bp,2
        loop    Shots_Update_loop
        popa
        ret
Shots_Update_missedshot:
        mov     ax,0
        mov     shots_stat[bp],ax
        popa
        ret
Shots_Update    endp



RedrawSprites   proc
        pusha

        mov     bp,0
        mov     cx,shots_MAX
RedrawSprites_shots_loop:
        mov     ax,shots_stat[bp]
        cmp     ax,0
        jz      RedrawSprites_shots_next
        lea     si,sprite_shot
        mov     ax,shots_x[bp]
        mov     bx,shots_y[bp]
        call    DrawSprite
RedrawSprites_shots_next:
        add     bp,2
        loop    RedrawSprites_shots_loop

        mov     bp,0
        mov     cx,pi_MAX
RedrawSprites_pi_loop:
        mov     ax,pi_stat[bp]
        cmp     ax,0
        je      RedrawSprites_pi_next
        cmp     ax,2
        je      RedrawSprites_pi_dead
        mov     ax,pi_speed[bp]
        cmp     ax,2
        jge     RedrawSprites_pi_2
        cmp     ax,-1
        jle     RedrawSprites_pi_2
        lea     si,sprite_pi
        mov     ax,pi_x[bp]
        mov     bx,pi_y[bp]
        call    DrawSprite
        jmp     RedrawSprites_pi_next
        RedrawSprites_pi_dead:
        lea     si,sprite_pidead
        mov     ax,pi_x[bp]
        mov     bx,pi_y[bp]
        call    DrawSprite
        jmp     RedrawSprites_pi_next
        RedrawSprites_pi_2:
        lea     si,sprite_pi2
        mov     ax,pi_x[bp]
        mov     bx,pi_y[bp]
        call    DrawSprite
        ;
        RedrawSprites_pi_next:
        add     bp,2
        loop    RedrawSprites_pi_loop

        lea     si,sprite_ship
        mov     ax,ship_x
        mov     bx,ship_y
        call    DrawSprite

        popa
        ret
RedrawSprites   endp



.data
seed              dw  0
Ten               dw  10
Value             dw 9421

Random_seed     Proc
                pusha
	        mov ax,40h
                mov es,ax
                mov ax, es:[06Ch]
                add ax, es:[06Eh]
                mov seed,ax          ; Store Seed
                popa
                ret
Random_seed     endp



Random          proc
                push bx
                push cx
                push dx

                mov ax,seed
                mul Value
                inc ax
                mov seed,ax         ; New seed value
                cwd			 
                idiv Ten
                cmp dx,0
                jnl Random_cont
	        neg dx
Random_cont:
                inc dx
                mov     ax,dx
                pop bx
                pop cx
                pop dx

                ret
Random          endp





ProcessKeys     proc
        pusha
        call    GetKeyPress
        mov     bx,gameover
        cmp     bx,0
        ja      ProcessKeys_ret
        cmp     ah,72
        je      ProcessKeys_Up
        cmp     ah,75
        je      ProcessKeys_Left
        cmp     ah,77
        je      ProcessKeys_Right
        cmp     ah,80
        je      ProcessKeys_Down
        cmp     ah,57
        je      ProcessKeys_Space
        cmp     ah,1
        je      ExitPoint
        popa
        ret

        ProcessKeys_Space:
        call    Shots_Fire
        jmp     ProcessKeys_ret

        ProcessKeys_Up:
        mov     ax,ship_y
        sub     ax,10
        cmp     ax,0
        jl      ProcessKeys_ret
        mov     ship_y,ax
        jmp     ProcessKeys_ret

        ProcessKeys_Down:
        mov     ax,ship_y
        add     ax,10
        cmp     ax,200-35
        jg      ProcessKeys_ret
        mov     ship_y,ax
        jmp     ProcessKeys_ret

        ProcessKeys_Left:
        mov     ax,ship_x
        sub     ax,10
        cmp     ax,0
        jl      ProcessKeys_ret
        mov     ship_x,ax
        jmp     ProcessKeys_ret

        ProcessKeys_Right:
        mov     ax,ship_x
        add     ax,10
        cmp     ax,320-35
        jg      ProcessKeys_ret
        mov     ship_x,ax

        ProcessKeys_ret:
        popa
        ret
ProcessKeys     endp


;;;;;;;;;;;;;;;;;;;;;;;;;;;;
InitGraphics         proc
;;;;;;;;;;;;;;;;;;;;;;;;;;;;
        pusha

        ; Set 256-color Video Mode
        mov     ah,00h
        mov     al,13h
        int     10h

        ; Set unchained mode
        SC_INDEX        equ          03c4h
        SC_DATA         equ          03c5h
        CRTC_INDEX      equ          03d4h
        CRTC_DATA       equ          03d5h
        MAP_MASK        equ          0x02     
        MEMORY_MODE     equ          04h
        UNDERLINE_LOC   equ          14h
        MODE_CONTROL    equ          17h

        mov     dx,SC_INDEX
        mov     al,MEMORY_MODE
        out     dx,al
        mov     dx,SC_DATA
        mov     al,06h
        out     dx,al

        mov     dx,CRTC_INDEX
        mov     al,UNDERLINE_LOC
        out     dx,al
        mov     dx,CRTC_DATA
        mov     al,00h
        out     dx,al

        mov     dx,CRTC_INDEX
        mov     al,MODE_CONTROL
        out     dx,al

        mov     dx,CRTC_DATA
        mov     al,0e3h
        out     dx,al

        ; Setup color palette
        mov     cx,3*palette_totalcolors
        lea     si,palette
        SetupPalette_loop:
        mov     ah,[si]
        shr     ah,2
        mov     [si],ah
        inc     si
        loop    SetupPalette_loop
        mov     ah,10h
        mov     al,12h
        mov     bx,0
        mov     cx,palette_totalcolors
        mov     dx,ds
        mov     es,dx
        lea     dx,palette
        int     10h

        popa
        ret                                  
InitGraphics         endp


;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ClearScreen             proc
;;;;;;;;;;;;;;;;;;;;;;;;;;;;
        pusha

        mov     dx,03c4h
        mov     ax,0ff02h
        out     dx,ax
        mov     cx,16000
        mov     ax,0a000h
        mov     es,ax
        mov     di,videobuffer
        mov     ah,0

        ClearScreen_loop:
        mov     es:[di],ah
        inc     di
        loop    ClearScreen_loop

        popa
        ret
ClearScreen             endp



spritex         dw      0
spritey         dw      0
x               dw      0
y               dw      0
plane           dw      0
imgstart        dw      0
screenoffset    dw      0
spritewidth     dw      0
spriteheight    dw      0
topclip         dw      0
bottomclip      dw      0
leftclip        dw      0
rightclip       dw      0
;;;;;;;;;;;;;;;;;;;;
DrawSprite      proc
;;;;;;;;;;;;;;;;;;;;
        pusha
        mov     spritex,ax        ; store x,y position
        mov     spritey,bx
        mov     ax,[si]
        mov     spritewidth,ax
        add     si,2
        mov     ax,[si]
        mov     spriteheight,ax
        add     si,2            ; image data = (char) sprite[3...]           
        mov     imgstart,si
        mov     ax,0a000h       ; es = video memory segment
        mov     es,ax
                       
                                   ; determine the clipping if any
        mov     ax,0
        mov     leftclip,ax
        mov     rightclip,ax
        mov     topclip,ax
        mov     bottomclip,ax

        mov     ax,spritex
        cmp     ax,0
        jnl     DrawSprite_clip1
        neg     ax
        mov     leftclip,ax
        mov     ax,0
        mov     spritex,ax
        DrawSprite_clip1:
        mov     ax,spritey
        cmp     ax,0
        jnl     DrawSprite_clip2
        neg     ax
        mov     topclip,ax
        DrawSprite_clip2:
        mov     ax,spritex
        mov     cx,320
        sub     cx,spritewidth
        cmp     ax,cx
        jng     DrawSprite_clip3
        sub     ax,cx
        mov     dx,spritewidth
        cmp     ax,dx
        jnl     DrawSprite_ret
        mov     rightclip,ax
        DrawSprite_clip3:
        mov     ax,spritey
        cmp     ax,200
        jng     DrawSprite_clip4
        mov     bx,200
        sub     ax,bx
        mov     bottomclip,ax
        DrawSprite_clip4:

        mov     ax,spritey          ; compute start offset in video memory
                                    ; di = (y<<6) + (y<<4) + (x>>2) 
        shl     ax,6                ;       + videobuffer
        mov     bx,spritey
        shl     bx,4
        add     ax,bx
        mov     bx,spritex
        shr     bx,2
        add     ax,bx
        add     ax,videobuffer
        sub     ax,leftclip
        mov     di,ax
        mov     screenoffset,ax        

        mov     ax,0
        mov     plane,ax
        
        ; for(plane=0;plane<4;plane++)
        DrawSprite_ForPlane_Loop:
        mov     ax,plane
        cmp     ax,4
        jnb     DrawSprite_ForPlane_End

        ;outp(SC_DATA,  1 << ((plane+object[i].x)&3) );                
        mov     dx,03c4h
        mov     ax,02h
        out     dx,ax
        mov     cx,plane
        mov     ax,spritex
        add     cx,ax
        and     cx,3
        mov     al,1
        sal     al,cl
        mov     dx,3c5h
        out     dx,al

       ; for(y=0;y<BITMAP_HEIGHT*bmp.width;y+=bmp.width)
        ;mov     ax,0
        mov     ax,topclip
        mov     y,ax
        DrawSprite_ForY_Loop:
        mov     ax,y
        mov     bx,spriteheight
        ;sub     bx,bottomclip
        cmp     ax,bx
        jnb     DrawSprite_ForY_End

       ; for(x=plane;x<BITMAP_WIDTH;x+=4)
        mov     ax,plane
        mov     bx,leftclip
        shl     bx,2
        add     ax,bx
        mov     x,ax
        DrawSprite_ForX_Loop:
        mov     ax,x
        mov     bx,spritewidth
        sub     bx,rightclip
        cmp     ax,bx
        jnb     DrawSprite_ForX_End

        ; bmp.data[bitmap_offset+y+x]
        mov     si,imgstart
        mov     ax,x
        add     si,ax
        mov     ax,y
        mov     dx,spritewidth
        mul     dx
        add     si,ax
        mov     al,[si]
        cmp     al,0
        je      DrawSprite_ForX_Continue

        ;active_page+screen_offset+(y>>2)+((x+(object[i].x&3)) >> 2)]=
        mov     di,screenoffset
        mov     ax,x
        mov     bx,spritex
        and     bx,3
        add     ax,bx
        shr     ax,2
        add     di,ax
        mov     ax,y
        mov     dx,80
        mul     dx
        add     di,ax
        mov     al,[si]
        mov     es:[di],al

        DrawSprite_ForX_Continue:
        mov     ax,x
        add     ax,4
        mov     x,ax
        jmp     DrawSprite_ForX_Loop
        DrawSprite_ForX_End:

        DrawSprite_ForY_Continue:
        mov     ax,y
        inc     ax
        mov     y,ax
        jmp     DrawSprite_ForY_Loop
        DrawSprite_ForY_End:

        DrawSprite_ForPlane_Continue:
        mov     ax,plane
        inc     ax
        mov     plane,ax
        jmp     DrawSprite_ForPlane_Loop
        DrawSprite_ForPlane_End:

        DrawSprite_ret:
                                                                                                              
        popa
        ret
DrawSprite      endp


.data
curx            dw      0
cury            dw      0
curcolor        db      0
DrawPixel       proc
        pusha
        mov     curcolor,dl
        mov     curx,ax
        mov     cury,bx

        mov     ah,[si]
        cmp     ah,0
        je      DrawPixel_skippixel
        mov     ax,curx
        cmp     ax,1
        jl      DrawPixel_skippixel
        cmp     ax,319
        jg      DrawPixel_skippixel
        mov     ax,cury
        cmp     ax,1
        jl      DrawPixel_skippixel
        cmp     ax,199
        jg      DrawPixel_skippixel

        mov     dx,03c4h
        mov     ax,02h
        out     dx,ax
        mov     cx,curx
        and     cx,3
        mov     al,1
        shl     al,cl
        mov     dx,3c5h
        out     dx,al
        mov     ax,cury
        mov     cl,6
        shl     ax,cl
        mov     bx,cury
        mov     cl,4
        shl     bx,cl
        add     ax,bx
        mov     bx,curx
        mov     cl,2
        shr     bx,cl
        add     ax,bx
        add     ax,videobuffer
        mov     di,ax
        mov     dl,curcolor
        mov     es:[di],dl

        DrawPixel_skippixel:
        popa
        ret
DrawPixel       endp


;;;;;;;;;;;;;;;;;;;;
DoVideo         proc
;;;;;;;;;;;;;;;;;;;;
        pusha
        mov     ax,videobuffer
        
        mov     bx,ax
        sal     bx,8
        or      bx,0Dh
        push    bx
        
        mov     bx,ax
        and     bx,0FF00h
        or      bx,0Ch
        push    bx


        DoVideo_cycle1:
        mov     dx,03dah
        in      al,dx
        and     al,01h
        cmp     al,0
        jne     DoVideo_cycle1

        cli
        pop     ax
        pop     bx
        mov     dx,CRTC_INDEX
        out     dx,ax
        mov     ax,bx
        mov     dx,CRTC_INDEX
        out     dx,ax
        sti

        DoVideo_cycle2:
        mov     dx,03dah
        in      al,dx
        and     al,08h
        cmp     al,0
        je      DoVideo_cycle2

        mov     ax,videobuffer
        add     ax,16000
        cmp     ax,64000
        jb      DoVideo_1

        mov     ax,0
        DoVideo_1:
        mov     videobuffer,ax


        popa
        ret
DoVideo         endp



;;;;;;;;;;;;;;;;;;;;;;;;;;;;
GetKeyPress            proc
;;;;;;;;;;;;;;;;;;;;;;;;;;;;
        ; returns last key pressed or
        ; zero if none
        ; OUTPUT
        ; ah = scan code
        ; al = ascii code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;
        mov     ah,01h
        int     16h
        jz      GetKeyPress_nokey
        mov     ah,00h
        int     16h
        ret

        GetKeyPress_nokey:
        mov     ah,0
        mov     al,0
        ret
GetKeyPress            endp

                        end 
                end





;       HOW TO WIN!
;       GET ALL THE PIs to stay on the screen.  There are 10.
;
;       If you shoot a slow moving PI once it will turn into a corpse
;       and continue falling toward you.  If you shoot a falling
;       corpse (ie shoot the slow PI twice) it will stay stuck on
;       the screen (you could say that it has the same velocity
;       as your ship).   Once you do this the PI won't come back
;       to haunt you for a while.  But after a while it will revive
;       so be quick.  Also those pesky fast moving PIs will bump
;       into the corpses and knock them down the screen.  Don't
;       let them fall off or they come back to life!  And don't
;       shoot stuck corpses cause they'll fly off into space
;       and get rivived by the mother ship, or something like that.
;
;       Well that's it,
;       Enjoy!
;
;       (C) 2001, Eric Hood
