.NOLIST
;Ŀ
;  P I  I n t r u d e r s     Main   (C) 1997, Eric Hood                
;
;
; This is the file you assemble with TASM.  All of the accompanying
; files should be in the same directory as this file.
;
; This file contains the main procedure which calls procedures in
; other files.
;
; Sorry for the lack of documentation.  This source might serve well
; as a generic backbone for other shoot'em up games.
;
; About the 'Timer' loop:  this is the main loop for the program.
; The loop calls the proc pointed to by each of the five timer
; pointers when their respective counters reach zero.  The initial
; counter value determines the frequency that the procedure
; executes or the delay before it executes.
;
; enjoy



.include "asm83.inc" ; include file with various TI contants

;;Timer Variables;;;;;;;;;;;;;;;;;;;;;
.define TotalTimers     5
.define KeyTimer        TIMERS+0
.define OutputTimer     TIMERS+24
.define Timer1          TIMERS+6
.define Timer2          TIMERS+12
.define Timer3          TIMERS+18

;;Variable Groups;;;;;;;;;;;;;;;;;;;;;
;  Many variables are stored at offsets of these base addresses
.define VARS_SHIP       VARS+20
.define VARS_PI         VARS+75
.define VARS_TITLE      VARS+15
.define VARS_SHOTS      VARS+50
.define VARS_GAMECON    VARS+5
.define VARS_GAME       VARS+10
.define i               VARS+0
.define x               VARS+2
.define oldcont         VARS+4

                       ;; ENTRY POINT
Code:   .org PROG
        call    Main
        RET

.include "const.asm"    ; game related constants
.include "inits.asm"    ; initialization procedures
.include "io.asm"       ; input output control
.include "ship.asm"     ; ship related logic
.include "shots.asm"    ; shot movement related logic
.include "pi.asm"       ; PI movement related logic
.include "gamecon.asm"  ; key binding logic
.include "title.asm"    ; title screen logic
.include "game.asm"     ; entry points for game states
.include "draw.asm"     ; drawing routines
.include "coldet.asm"   ; collision detection
.include "levels.asm"   ; difficulty progression
.include "procs83.asm"  ; this file contains misc routines

Main:
        call    InitEnvironment
        call    Title_Init
        call    StartTimer
        call    CleanUp
        RET

.include "data.asm"
.END
